'use strict';

const watchers = require('./watchers-0dfdf839.js');
const mutations$1 = require('./mutations-65ccc5d3.js');
const mutations = require('./mutations-9a574243.js');
const addQueryArgs = require('./add-query-args-17c551b6.js');

const submitCartForm = async (productId) => {
  var _a, _b, _c, _d, _e, _f;
  const productState = watchers.state[productId];
  if (!productState)
    return;
  if (!((_a = productState.selectedPrice) === null || _a === void 0 ? void 0 : _a.id))
    return;
  if (((_b = productState.selectedPrice) === null || _b === void 0 ? void 0 : _b.ad_hoc) && (null === productState.adHocAmount || undefined === productState.adHocAmount))
    return;
  try {
    watchers.setProduct(productId, { busy: true });
    await mutations.addCheckoutLineItem({
      price: (_c = productState.selectedPrice) === null || _c === void 0 ? void 0 : _c.id,
      quantity: Math.max(((_d = productState.selectedPrice) === null || _d === void 0 ? void 0 : _d.ad_hoc) ? 1 : productState.quantity, 1),
      ...(((_e = productState.selectedPrice) === null || _e === void 0 ? void 0 : _e.ad_hoc) ? { ad_hoc_amount: productState.adHocAmount } : {}),
      variant: (_f = productState.selectedVariant) === null || _f === void 0 ? void 0 : _f.id,
    });
    mutations$1.toggleCart(true);
    watchers.setProduct(productId, { dialog: null });
  }
  catch (e) {
    console.error(e);
    watchers.state.error = e;
    throw e; // Re-throw the caught error
  }
  finally {
    watchers.setProduct(productId, { busy: false });
  }
};
/**
 * Get the product buy link.
 */
const getProductBuyLink = (productId, url, query = {}) => {
  var _a, _b, _c, _d, _e, _f, _g;
  const productState = watchers.state[productId];
  if (!productState)
    return;
  if (!((_a = productState.selectedPrice) === null || _a === void 0 ? void 0 : _a.id))
    return;
  if (((_b = productState.selectedPrice) === null || _b === void 0 ? void 0 : _b.ad_hoc) && !productState.adHocAmount)
    return;
  return addQueryArgs.addQueryArgs(url, {
    line_items: [
      {
        price: (_c = productState.selectedPrice) === null || _c === void 0 ? void 0 : _c.id,
        quantity: Math.max(((_d = productState.selectedPrice) === null || _d === void 0 ? void 0 : _d.ad_hoc) ? 1 : productState.quantity, 1),
        ...(((_e = productState.selectedPrice) === null || _e === void 0 ? void 0 : _e.ad_hoc) ? { ad_hoc_amount: productState.adHocAmount } : {}),
        ...(((_f = productState.selectedVariant) === null || _f === void 0 ? void 0 : _f.id) ? { variant: (_g = productState.selectedVariant) === null || _g === void 0 ? void 0 : _g.id } : {}),
      },
    ],
    ...query,
  });
};

/**
 * Get any additional error messages.
 */
const getAdditionalErrorMessages = error => ((error === null || error === void 0 ? void 0 : error.additional_errors) || []).map(error => error.message);
/**
 * Get the top level error
 */
const getTopLevelError = (error) => {
  var _a;
  // checkout invalid is not friendly.
  if ((error === null || error === void 0 ? void 0 : error.code) === 'checkout.invalid' && ((_a = getAdditionalErrorMessages(error)) === null || _a === void 0 ? void 0 : _a.length)) {
    return '';
  }
  return error === null || error === void 0 ? void 0 : error.message;
};

exports.getAdditionalErrorMessages = getAdditionalErrorMessages;
exports.getProductBuyLink = getProductBuyLink;
exports.getTopLevelError = getTopLevelError;
exports.submitCartForm = submitCartForm;

//# sourceMappingURL=error-a04d0dab.js.map