'use strict';

const addQueryArgs = require('./add-query-args-17c551b6.js');

/**
 * Internal dependencies
 */
/**
 * @typedef {{[key: string]: QueryArgParsed}} QueryArgObject
 */

/**
 * @typedef {string|string[]|QueryArgObject} QueryArgParsed
 */

/**
 * Returns a single query argument of the url
 *
 * @param {string} url URL.
 * @param {string} arg Query arg name.
 *
 * @example
 * ```js
 * const foo = getQueryArg( 'https://wordpress.org?foo=bar&bar=baz', 'foo' ); // bar
 * ```
 *
 * @return {QueryArgParsed|void} Query arg value.
 */

function getQueryArg(url, arg) {
  return addQueryArgs.getQueryArgs(url)[arg];
}

exports.getQueryArg = getQueryArg;

//# sourceMappingURL=get-query-arg-53bf21e2.js.map