'use strict';

const mutations = require('./mutations-65ccc5d3.js');

/**
 * Gets the current checkout for the page.
 */
const currentCheckout = () => mutations.getCheckout(mutations.state.formId, mutations.state.mode);
/**
 * Is the checkout currently locked.
 * Pass an optional lock name to find if a
 * specific lock name is locking checkout.
 */
const checkoutIsLocked = (lockName = '') => { var _a; return (lockName ? mutations.state.locks.some(name => name === lockName) : !!((_a = mutations.state.locks) === null || _a === void 0 ? void 0 : _a.length)); };
/**
 * Get a line item by product id.
 */
const getLineItemByProductId = (productId) => { var _a, _b; return (((_b = (_a = mutations.state.checkout) === null || _a === void 0 ? void 0 : _a.line_items) === null || _b === void 0 ? void 0 : _b.data) || []).find(line_item => { var _a, _b; return ((_b = (_a = line_item === null || line_item === void 0 ? void 0 : line_item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id) === productId; }); };
/**
 * Is the shipping address required?
 */
const fullShippingAddressRequired = () => { var _a, _b; return ((_a = mutations.state.checkout) === null || _a === void 0 ? void 0 : _a.shipping_enabled) || ((_b = mutations.state === null || mutations.state === void 0 ? void 0 : mutations.state.checkout) === null || _b === void 0 ? void 0 : _b.shipping_address_required); };
/**
 * Is the address required?
 */
const shippingAddressRequired = () => { var _a, _b, _c, _d; return ((_a = mutations.state.checkout) === null || _a === void 0 ? void 0 : _a.tax_status) === 'address_invalid' || ((_b = mutations.state.checkout) === null || _b === void 0 ? void 0 : _b.shipping_enabled) || ((_c = mutations.state.checkout) === null || _c === void 0 ? void 0 : _c.shipping_address_required) || ((_d = mutations.state === null || mutations.state === void 0 ? void 0 : mutations.state.checkout) === null || _d === void 0 ? void 0 : _d.tax_enabled); };

exports.checkoutIsLocked = checkoutIsLocked;
exports.currentCheckout = currentCheckout;
exports.fullShippingAddressRequired = fullShippingAddressRequired;
exports.getLineItemByProductId = getLineItemByProductId;
exports.shippingAddressRequired = shippingAddressRequired;

//# sourceMappingURL=getters-32d40d5e.js.map