'use strict';

const store = require('./store-dc663ece.js');
const index = require('./index-8604ebe6.js');

// Start state machine.
const service = store.v(store.checkoutMachine);
service.subscribe(stateService => (store.state.formState = stateService));
service.start();
// on change formState, speak the current state.
store.onChange('formState', () => {
  const { formState } = store.state;
  const { value } = formState;
  if (store.state.text.loading[value] === undefined)
    return;
  index.speak(store.state.text.loading[value], 'assertive');
});

const { send } = service;
const updateFormState = action => send(action);

exports.updateFormState = updateFormState;

//# sourceMappingURL=mutations-e2dd0da5.js.map