import { h } from '@stencil/core';
import { state as checkoutState } from '@store/checkout';
export class ScCartLoader {
  constructor() {
    this.template = undefined;
  }
  render() {
    var _a;
    // check for forms.
    if (document.querySelector('sc-checkout')) {
      return;
    }
    // clear the order if it's already paid.
    if (((_a = checkoutState === null || checkoutState === void 0 ? void 0 : checkoutState.checkout) === null || _a === void 0 ? void 0 : _a.status) === 'paid') {
      checkoutState.checkout = null;
      return null;
    }
    // return the loader.
    return h("div", { innerHTML: this.template || '' });
  }
  static get is() { return "sc-cart-loader"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-cart-loader.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-cart-loader.css"]
    };
  }
  static get properties() {
    return {
      "template": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The cart template to inject when opened."
        },
        "attribute": "template",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-cart-loader.js.map
