import { h, Host } from '@stencil/core';
import { __, sprintf } from '@wordpress/i18n';
import { isInRange } from '../../../../functions/util';
import { state as donationState } from '@store/product-donation';
import { updateDonationState as update } from '@store/product-donation/mutations';
import { getInRangeAmounts } from '@store/product-donation/getters';
export class ScProductDonationAmountChoice {
  constructor() {
    this.productId = undefined;
    this.value = undefined;
    this.label = undefined;
  }
  state() {
    return donationState[this.productId];
  }
  render() {
    var _a;
    const amounts = getInRangeAmounts(this.productId);
    const order = amounts.indexOf(this.value);
    if (!isInRange(this.value, this.state().selectedPrice) || order < 0)
      return h(Host, { style: { display: 'none' } });
    return (h("sc-choice-container", { "show-control": "false", checked: this.state().ad_hoc_amount === this.value, onScChange: () => update(this.productId, { ad_hoc_amount: this.value, custom_amount: null }), "aria-label": sprintf(__('%s of %s', 'surecart'), order + 1, amounts.length), role: "button" }, this.label ? (this.label) : (h("sc-format-number", { type: "currency", currency: (_a = this.state().selectedPrice) === null || _a === void 0 ? void 0 : _a.currency, value: this.value, "minimum-fraction-digits": "0" }))));
  }
  static get is() { return "sc-product-donation-amount-choice"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-donation-amount-choice.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-donation-amount-choice.css"]
    };
  }
  static get properties() {
    return {
      "productId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The product id for the fields."
        },
        "attribute": "product-id",
        "reflect": true
      },
      "value": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The value of the field."
        },
        "attribute": "value",
        "reflect": false
      },
      "label": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The label for the field."
        },
        "attribute": "label",
        "reflect": false
      }
    };
  }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=sc-product-donation-amount-choice.js.map
