import { h, Host } from '@stencil/core';
import { __ } from '@wordpress/i18n';
import { state as donationState } from '@store/product-donation';
export class ScProductDonationCustomAmount {
  constructor() {
    this.productId = undefined;
    this.value = undefined;
  }
  state() {
    return donationState[this.productId];
  }
  updateState(data) {
    donationState[this.productId] = {
      ...donationState[this.productId],
      ...data,
    };
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const checked = !!((_a = this.state()) === null || _a === void 0 ? void 0 : _a.custom_amount);
    return (h(Host, { class: { 'sc-product-donation-custom-amount': true, 'sc-product-donation-custom-amount--has-value': !!this.value } }, h("sc-choice-container", { value: `${(_b = this.state()) === null || _b === void 0 ? void 0 : _b.custom_amount}`, "show-control": "false", checked: checked, onClick: () => this.priceInput.triggerFocus(), onKeyDown: () => {
        this.priceInput.triggerFocus();
      }, role: "button" }, h("sc-visually-hidden", null, __('Enter a custom amount.', 'surecart')), h("sc-price-input", { ref: el => (this.priceInput = el), currencyCode: ((_d = (_c = this.state()) === null || _c === void 0 ? void 0 : _c.selectedPrice) === null || _d === void 0 ? void 0 : _d.currency) || ((_e = window === null || window === void 0 ? void 0 : window.scData) === null || _e === void 0 ? void 0 : _e.currency) || 'usd', showCode: false, showLabel: false, value: `${((_f = this.state()) === null || _f === void 0 ? void 0 : _f.custom_amount) || ''}`, onScChange: e => this.updateState({
        ad_hoc_amount: null,
        custom_amount: e.target.value,
      }), min: (_h = (_g = this.state()) === null || _g === void 0 ? void 0 : _g.selectedPrice) === null || _h === void 0 ? void 0 : _h.ad_hoc_min_amount, max: (_k = (_j = this.state()) === null || _j === void 0 ? void 0 : _j.selectedPrice) === null || _k === void 0 ? void 0 : _k.ad_hoc_max_amount, style: { '--sc-input-border-color-focus': 'var(--sc-input-border-color-hover)', '--sc-focus-ring-color-primary': 'transparent' } }))));
  }
  static get is() { return "sc-product-donation-custom-amount"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-donation-custom-amount.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-donation-custom-amount.css"]
    };
  }
  static get properties() {
    return {
      "productId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Selected Product Id for the donation."
        },
        "attribute": "product-id",
        "reflect": false
      },
      "value": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Custom Amount of the donation."
        },
        "attribute": "value",
        "reflect": false
      }
    };
  }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=sc-product-donation-custom-amount.js.map
