import { Host, h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
import { state as formState } from '@store/form';
import { state as checkoutState } from '@store/checkout';
export class ScLineItemShipping {
  constructor() {
    this.label = undefined;
  }
  render() {
    const { checkout } = checkoutState;
    // don't show if no shipping amount if no choice selected
    if (!(checkout === null || checkout === void 0 ? void 0 : checkout.selected_shipping_choice)) {
      return h(Host, { style: { display: 'none' } });
    }
    if (formState.formState.value === 'loading') {
      return (h("sc-line-item", null, h("sc-skeleton", { slot: "title", style: { width: '120px', display: 'inline-block' } }), h("sc-skeleton", { slot: "price", style: { 'width': '70px', 'display': 'inline-block', '--border-radius': '6px' } })));
    }
    return (h("sc-line-item", null, h("span", { slot: "description" }, this.label || __('Shipping', 'surecart')), h("span", { slot: "price" }, (checkout === null || checkout === void 0 ? void 0 : checkout.shipping_amount) ? (h("sc-format-number", { type: "currency", currency: checkout === null || checkout === void 0 ? void 0 : checkout.currency, value: checkout === null || checkout === void 0 ? void 0 : checkout.shipping_amount })) : (__('Free', 'surecart')))));
  }
  static get is() { return "sc-line-item-shipping"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-line-item-shipping.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-line-item-shipping.css"]
    };
  }
  static get properties() {
    return {
      "label": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Label"
        },
        "attribute": "label",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-line-item-shipping.js.map
