import { h, Host } from '@stencil/core';
import { openWormhole } from 'stencil-wormhole';
export class ScOrderManualInstructions {
  constructor() {
    this.manualPaymentTitle = undefined;
    this.manualPaymentInstructions = undefined;
  }
  render() {
    if (!this.manualPaymentInstructions || !this.manualPaymentTitle) {
      return h(Host, { style: { display: 'none' } });
    }
    return (h("sc-alert", { type: "info", open: true }, h("span", { slot: "title" }, this.manualPaymentTitle), h("div", { innerHTML: this.manualPaymentInstructions })));
  }
  static get is() { return "sc-order-manual-instructions"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-order-manual-instructions.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-order-manual-instructions.css"]
    };
  }
  static get properties() {
    return {
      "manualPaymentTitle": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "manual-payment-title",
        "reflect": false
      },
      "manualPaymentInstructions": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "manual-payment-instructions",
        "reflect": false
      }
    };
  }
}
openWormhole(ScOrderManualInstructions, ['manualPaymentTitle', 'manualPaymentInstructions'], false);
//# sourceMappingURL=sc-order-manual-instructions.js.map
