import { h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
import { openWormhole } from 'stencil-wormhole';
export class ScOrderConfirmationCustomer {
  constructor() {
    this.order = undefined;
    this.heading = undefined;
    this.customer = undefined;
    this.error = undefined;
    this.loading = undefined;
  }
  render() {
    if (!this.customer) {
      return null;
    }
    return (h("sc-customer-details", { customer: this.customer, loading: this.loading, error: this.error }, h("span", { slot: "heading" }, h("slot", { name: "heading" }, this.heading || __('Billing Details', 'surecart')))));
  }
  static get is() { return "sc-order-confirmation-customer"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-order-confirmation-customer.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-order-confirmation-customer.css"]
    };
  }
  static get properties() {
    return {
      "order": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Checkout",
          "resolved": "Checkout",
          "references": {
            "Checkout": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The Order"
        }
      },
      "heading": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The heading"
        },
        "attribute": "heading",
        "reflect": false
      },
      "customer": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Customer",
          "resolved": "Customer",
          "references": {
            "Customer": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The customer"
        }
      },
      "error": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Error message."
        },
        "attribute": "error",
        "reflect": false
      },
      "loading": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Is this loading?"
        },
        "attribute": "loading",
        "reflect": false
      }
    };
  }
}
openWormhole(ScOrderConfirmationCustomer, ['order', 'customer', 'loading'], false);
//# sourceMappingURL=sc-order-confirmation-customer.js.map
