import withMock from 'storybook-addon-mock';
export default {
  title: 'Components/Dashboard/DownloadsList',
  decorators: [withMock],
};
const Template = ({ heading }) => `<sc-dashboard-downloads-list heading="${heading}"></sc-dashboard-downloads-list>`;
export const Default = Template.bind({});
Default.args = {
  heading: 'Downloads',
  allLink: true,
};
Default.parameters = {
  mockData: [
    {
      url: '/surecart/v1/purchases/?expand%5B0%5D=product&expand%5B1%5D=product.downloads&downloadable=true&page=1&per_page=10&_locale=user',
      method: 'GET',
      status: 200,
      response: [
        {
          id: 'd3fe5642-db02-497e-b93c-04e4852551f2',
          object: 'purchase',
          product: {
            name: 'Purchase with download',
            files: {
              object: 'list',
              pagination: { count: 5 },
              data: [
                {
                  byte_size: 164253,
                },
                {
                  byte_size: 16425300,
                },
                {
                  byte_size: 164253,
                },
                {
                  byte_size: 164253,
                },
                {
                  byte_size: 164253,
                },
              ],
            },
          },
        },
        {
          id: 'd3fe5642-db02-497e-b93c-04e4852551f2',
          object: 'purchase',
          product: {
            name: 'Purchase with download',
            files: {
              object: 'list',
              pagination: { count: 2 },
              data: [
                {
                  byte_size: 164253,
                },
                {
                  byte_size: 164253,
                },
                {
                  byte_size: 164253,
                },
              ],
            },
          },
        },
      ],
    },
  ],
};
//# sourceMappingURL=sc-dashboard-downloads-list.stories.js.map
