import { h } from '@stencil/core';
import { addQueryArgs } from '@wordpress/url';
import apiFetch from '../../../../functions/fetch';
import { getCurrentBehaviourContent } from './functions';
export class ScCancelDiscount {
  constructor() {
    this.subscription = undefined;
    this.reason = undefined;
    this.comment = undefined;
    this.protocol = undefined;
    this.loading = undefined;
    this.error = undefined;
  }
  async addDiscount() {
    var _a, _b;
    try {
      this.loading = true;
      this.subscription = (await apiFetch({
        method: 'PATCH',
        path: addQueryArgs(`surecart/v1/subscriptions/${(_a = this.subscription) === null || _a === void 0 ? void 0 : _a.id}/preserve`, {
          cancellation_act: {
            ...(!!this.comment ? { comment: this.comment } : {}),
            cancellation_reason_id: (_b = this.reason) === null || _b === void 0 ? void 0 : _b.id,
          },
        }),
      }));
      this.scPreserved.emit();
    }
    catch (e) {
      console.error(e);
      this.error = e;
    }
    finally {
      this.loading = false;
    }
  }
  hasDiscount() {
    var _a, _b;
    return !!((_b = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.discount) === null || _b === void 0 ? void 0 : _b.id);
  }
  render() {
    var _a, _b;
    const { title, description, button, cancel_link } = getCurrentBehaviourContent(this.protocol, (_b = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.discount) === null || _b === void 0 ? void 0 : _b.id);
    return (h("div", { class: "cancel-discount" }, h("sc-dashboard-module", { heading: title, style: { '--sc-dashboard-module-spacing': '2em' } }, h("span", { slot: "description" }, description), h("sc-flex", { justifyContent: "flex-start" }, h("sc-button", { type: "primary", onClick: () => this.addDiscount() }, button), h("sc-button", { class: "cancel-discount__abort-link", type: "text", onClick: () => this.scCancel.emit() }, cancel_link)), !!this.loading && h("sc-block-ui", { spinner: true }))));
  }
  static get is() { return "sc-cancel-discount"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-cancel-discount.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-cancel-discount.css"]
    };
  }
  static get properties() {
    return {
      "subscription": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Subscription",
          "resolved": "Subscription",
          "references": {
            "Subscription": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "reason": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "CancellationReason",
          "resolved": "CancellationReason",
          "references": {
            "CancellationReason": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "comment": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "comment",
        "reflect": false
      },
      "protocol": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "SubscriptionProtocol",
          "resolved": "SubscriptionProtocol",
          "references": {
            "SubscriptionProtocol": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
  static get states() {
    return {
      "loading": {},
      "error": {}
    };
  }
  static get events() {
    return [{
        "method": "scCancel",
        "name": "scCancel",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "void",
          "resolved": "void",
          "references": {}
        }
      }, {
        "method": "scPreserved",
        "name": "scPreserved",
        "bubbles": true,
        "cancelable": true,
        "composed": true,
        "docs": {
          "tags": [],
          "text": ""
        },
        "complexType": {
          "original": "void",
          "resolved": "void",
          "references": {}
        }
      }];
  }
}
//# sourceMappingURL=sc-cancel-discount.js.map
