import { h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
import { addQueryArgs } from '@wordpress/url';
import { getVariantFromValues } from '../../../../functions/util';
export class ScSubscriptionVariationConfirm {
  constructor() {
    this.heading = undefined;
    this.product = undefined;
    this.price = undefined;
    this.subscription = undefined;
    this.busy = false;
    this.variantValues = [];
    // Bind the submit function to the component instance
    this.handleSubmit = this.handleSubmit.bind(this);
  }
  componentWillLoad() {
    var _a;
    this.variantValues = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.variant_options;
  }
  async handleSubmit() {
    var _a, _b, _c, _d;
    this.busy = true;
    const selectedVariant = getVariantFromValues({ variants: (_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.variants) === null || _b === void 0 ? void 0 : _b.data, values: this.variantValues });
    // confirm ad_hoc amount.
    if ((_c = this.price) === null || _c === void 0 ? void 0 : _c.ad_hoc) {
      return window.location.assign(addQueryArgs(window.location.href, {
        action: 'confirm_amount',
        price_id: (_d = this.price) === null || _d === void 0 ? void 0 : _d.id,
        variant: selectedVariant === null || selectedVariant === void 0 ? void 0 : selectedVariant.id,
      }));
    }
    return window.location.assign(addQueryArgs(window.location.href, {
      action: 'confirm',
      variant: selectedVariant === null || selectedVariant === void 0 ? void 0 : selectedVariant.id,
    }));
  }
  buttonText() {
    var _a, _b, _c, _d;
    if ((_a = this.price) === null || _a === void 0 ? void 0 : _a.ad_hoc) {
      if (((_b = this.price) === null || _b === void 0 ? void 0 : _b.id) === ((_d = (_c = this.subscription) === null || _c === void 0 ? void 0 : _c.price) === null || _d === void 0 ? void 0 : _d.id)) {
        return __('Update Amount', 'surecart');
      }
      return __('Choose Amount', 'surecart');
    }
    return __('Next', 'surecart');
  }
  render() {
    var _a, _b;
    return (h("sc-dashboard-module", { heading: this.heading || __('Enter An Amount', 'surecart'), class: "subscription-switch" }, h("sc-card", null, h("sc-form", { onScSubmit: this.handleSubmit }, h("div", { class: "sc-product-variation-choice-wrap" }, (((_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.variant_options) === null || _b === void 0 ? void 0 : _b.data) || []).map(({ name, values, id }, index) => {
      var _a, _b;
      return (h("sc-select", { exportparts: "base:select__base, input, form-control, label, help-text, trigger, panel, caret, menu__base, spinner__base, empty", part: "name__input", value: ((_b = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.variant_options) === null || _b === void 0 ? void 0 : _b[index]) || '', onScChange: (e) => {
          this.variantValues[index] = e.detail.value;
        }, label: name, choices: values === null || values === void 0 ? void 0 : values.map(label => ({
          label,
          value: label,
        })), unselect: false, key: id }));
    })), h("sc-button", { type: "primary", full: true, submit: true, loading: this.busy }, this.buttonText(), " ", h("sc-icon", { name: "arrow-right", slot: "suffix" })))), this.busy && h("sc-block-ui", { style: { zIndex: '9' } })));
  }
  static get is() { return "sc-subscription-variation-confirm"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-subscription-variation-confirm.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-subscription-variation-confirm.css"]
    };
  }
  static get properties() {
    return {
      "heading": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "heading",
        "reflect": false
      },
      "product": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Product",
          "resolved": "Product",
          "references": {
            "Product": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "price": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Price",
          "resolved": "Price",
          "references": {
            "Price": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "subscription": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Subscription",
          "resolved": "Subscription",
          "references": {
            "Subscription": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
  static get states() {
    return {
      "busy": {},
      "variantValues": {}
    };
  }
}
//# sourceMappingURL=sc-subscription-variation-confirm.js.map
