import { Fragment, h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
import { addQueryArgs } from '@wordpress/url';
export class ScWordPressUser {
  constructor() {
    this.heading = undefined;
    this.user = undefined;
  }
  renderContent() {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    if (!this.user) {
      return this.renderEmpty();
    }
    return (h(Fragment, null, !!((_a = this === null || this === void 0 ? void 0 : this.user) === null || _a === void 0 ? void 0 : _a.display_name) && (h("sc-stacked-list-row", { style: { '--columns': '3' }, mobileSize: 480 }, h("div", null, h("strong", null, __('Display Name', 'surecart'))), h("div", null, (_b = this.user) === null || _b === void 0 ? void 0 : _b.display_name), h("div", null))), !!((_c = this === null || this === void 0 ? void 0 : this.user) === null || _c === void 0 ? void 0 : _c.email) && (h("sc-stacked-list-row", { style: { '--columns': '3' }, mobileSize: 480 }, h("div", null, h("strong", null, __('Account Email', 'surecart'))), h("div", null, (_d = this.user) === null || _d === void 0 ? void 0 : _d.email), h("div", null))), !!((_e = this === null || this === void 0 ? void 0 : this.user) === null || _e === void 0 ? void 0 : _e.first_name) && (h("sc-stacked-list-row", { style: { '--columns': '3' }, mobileSize: 480 }, h("div", null, h("strong", null, __('First Name', 'surecart'))), h("div", null, (_f = this.user) === null || _f === void 0 ? void 0 : _f.first_name), h("div", null))), !!((_g = this === null || this === void 0 ? void 0 : this.user) === null || _g === void 0 ? void 0 : _g.last_name) && (h("sc-stacked-list-row", { style: { '--columns': '3' }, mobileSize: 480 }, h("div", null, h("strong", null, __('Last Name', 'surecart'))), h("div", null, (_h = this.user) === null || _h === void 0 ? void 0 : _h.last_name), h("div", null)))));
  }
  renderEmpty() {
    return h("slot", { name: "empty" }, __('User not found.', 'surecart'));
  }
  render() {
    return (h("sc-dashboard-module", { class: "customer-details" }, h("span", { slot: "heading" }, this.heading || __('Account Details', 'surecart'), " "), h("sc-button", { type: "link", href: addQueryArgs(window.location.href, {
        action: 'edit',
        model: 'user',
      }), slot: "end" }, h("sc-icon", { name: "edit-3", slot: "prefix" }), __('Update', 'surecart')), h("sc-card", { "no-padding": true }, h("sc-stacked-list", null, this.renderContent()))));
  }
  static get is() { return "sc-wordpress-user"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-wordpress-user.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-wordpress-user.css"]
    };
  }
  static get properties() {
    return {
      "heading": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "heading",
        "reflect": false
      },
      "user": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "WordPressUser",
          "resolved": "WordPressUser",
          "references": {
            "WordPressUser": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
}
//# sourceMappingURL=sc-wordpress-user.js.map
