import { Host, h } from '@stencil/core';
import { state } from '@store/product';
export class ScProductText {
  constructor() {
    this.text = 'name';
    this.productId = undefined;
  }
  render() {
    var _a;
    const product = (_a = state[this.productId]) === null || _a === void 0 ? void 0 : _a.product;
    if (product === null || product === void 0 ? void 0 : product[this.text]) {
      return h("span", { style: { whiteSpace: 'pre-line' }, innerHTML: product[this.text] });
    }
    return (h(Host, null, h("slot", null)));
  }
  static get is() { return "sc-product-text"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-text.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-text.css"]
    };
  }
  static get properties() {
    return {
      "text": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'name' | 'description'",
          "resolved": "\"description\" | \"name\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "text",
        "reflect": false,
        "defaultValue": "'name'"
      },
      "productId": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "product-id",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-product-text.js.map
