import { h, Host } from '@stencil/core';
import { sizeImage } from '../../../../functions/media';
import { applyFilters } from '@wordpress/hooks';
import { getFeaturedProductMediaAttributes } from 'src/functions/media';
export class ScProductItemImage {
  constructor() {
    this.product = undefined;
    this.sizing = undefined;
  }
  getSrc() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    if ((_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.featured_product_media) === null || _b === void 0 ? void 0 : _b.url) {
      return (_d = (_c = this.product) === null || _c === void 0 ? void 0 : _c.featured_product_media) === null || _d === void 0 ? void 0 : _d.url;
    }
    if ((_g = (_f = (_e = this.product) === null || _e === void 0 ? void 0 : _e.featured_product_media) === null || _f === void 0 ? void 0 : _f.media) === null || _g === void 0 ? void 0 : _g.url) {
      return sizeImage((_k = (_j = (_h = this.product) === null || _h === void 0 ? void 0 : _h.featured_product_media) === null || _j === void 0 ? void 0 : _j.media) === null || _k === void 0 ? void 0 : _k.url, applyFilters('surecart/product-list/media/size', 900));
    }
    return `${(_l = window.scData) === null || _l === void 0 ? void 0 : _l.plugin_url}/images/placeholder.jpg`;
  }
  render() {
    const { alt, title } = getFeaturedProductMediaAttributes(this.product);
    return (h(Host, { style: { borderStyle: 'none' } }, h("div", { class: {
        'product-img': true,
        'is_contained': this.sizing === 'contain',
        'is_covered': this.sizing === 'cover',
      } }, !!this.getSrc() ? h("img", { src: this.getSrc(), alt: alt, ...(title ? { title } : {}) }) : h("div", { class: "product-img_placeholder" }))));
  }
  static get is() { return "sc-product-item-image"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-item-image.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-item-image.css"]
    };
  }
  static get properties() {
    return {
      "product": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Product",
          "resolved": "Product",
          "references": {
            "Product": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "sizing": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'cover' | 'contain'",
          "resolved": "\"contain\" | \"cover\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "sizing",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-product-item-image.js.map
