import { h } from '@stencil/core';
export class ScProductItemPrice {
  constructor() {
    this.prices = undefined;
    this.range = true;
    this.metrics = undefined;
  }
  componentWillLoad() {
    var _a, _b, _c, _d, _e, _f;
    // If min-max price is different, then generate a price range.
    if (this.range && ((_a = this.metrics) === null || _a === void 0 ? void 0 : _a.min_price_amount) !== ((_b = this.metrics) === null || _b === void 0 ? void 0 : _b.max_price_amount)) {
      this.prices = [
        {
          amount: (_c = this.metrics) === null || _c === void 0 ? void 0 : _c.min_price_amount,
          currency: (_d = this.metrics) === null || _d === void 0 ? void 0 : _d.currency,
        },
        {
          amount: (_e = this.metrics) === null || _e === void 0 ? void 0 : _e.max_price_amount,
          currency: (_f = this.metrics) === null || _f === void 0 ? void 0 : _f.currency,
        },
      ];
    }
  }
  render() {
    var _a;
    const price = (this.prices || []).sort((a, b) => (a === null || a === void 0 ? void 0 : a.position) - (b === null || b === void 0 ? void 0 : b.position)).find(price => !(price === null || price === void 0 ? void 0 : price.archived));
    return (h("div", { class: "product-price", part: "base" }, !this.range && ((_a = this.prices) === null || _a === void 0 ? void 0 : _a.length) ? (h("sc-format-number", { type: "currency", currency: (price === null || price === void 0 ? void 0 : price.currency) || 'usd', value: price === null || price === void 0 ? void 0 : price.amount })) : (h("sc-price-range", { prices: this.prices }))));
  }
  static get is() { return "sc-product-item-price"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-item-price.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-item-price.css"]
    };
  }
  static get properties() {
    return {
      "prices": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Price[]",
          "resolved": "Price[]",
          "references": {
            "Price": {
              "location": "import",
              "path": "src/types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "range": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Show price range?"
        },
        "attribute": "range",
        "reflect": false,
        "defaultValue": "true"
      },
      "metrics": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "ProductMetrics",
          "resolved": "ProductMetrics",
          "references": {
            "ProductMetrics": {
              "location": "import",
              "path": "src/types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Product metrics"
        }
      }
    };
  }
}
//# sourceMappingURL=sc-product-item-price.js.map
