import { h } from '@stencil/core';
export class ScProductItem {
  constructor() {
    this.product = undefined;
    this.layoutConfig = undefined;
  }
  render() {
    var _a;
    return (h("a", { href: (_a = this.product) === null || _a === void 0 ? void 0 : _a.permalink, class: { 'product-item': true } }, this.product &&
      (this.layoutConfig || []).map(layout => {
        var _a, _b, _c, _d;
        const attributes = layout.attributes || {};
        switch (layout.blockName) {
          case 'surecart/product-item-title':
            return h("sc-product-item-title", { part: "title" }, (_a = this.product) === null || _a === void 0 ? void 0 : _a.name);
          case 'surecart/product-item-image':
            return h("sc-product-item-image", { part: "image", product: this.product, sizing: (_b = layout.attributes) === null || _b === void 0 ? void 0 : _b.sizing });
          case 'surecart/product-item-price':
            return h("sc-product-item-price", { part: "price", prices: (_c = this.product) === null || _c === void 0 ? void 0 : _c.prices.data, range: !!(attributes === null || attributes === void 0 ? void 0 : attributes.range), metrics: (_d = this.product) === null || _d === void 0 ? void 0 : _d.metrics });
          default:
            return null;
        }
      })));
  }
  static get is() { return "sc-product-item"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-product-item.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-product-item.css"]
    };
  }
  static get properties() {
    return {
      "product": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "Product",
          "resolved": "Product",
          "references": {
            "Product": {
              "location": "import",
              "path": "../../../../types"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      },
      "layoutConfig": {
        "type": "unknown",
        "mutable": false,
        "complexType": {
          "original": "LayoutConfig",
          "resolved": "{ blockName: string; attributes: any; }[]",
          "references": {
            "LayoutConfig": {
              "location": "import",
              "path": "../sc-product-item-list/sc-product-item-list"
            }
          }
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        }
      }
    };
  }
}
//# sourceMappingURL=sc-product-item.js.map
