/**
 * External dependencies.
 */
import { Host, h } from '@stencil/core';
import { getFormattedRemainingTime } from '@store/upsell/getters';
export class ScUpsellCountdownTimer {
  constructor() {
    this.timeRemaining = Infinity;
    this.formattedTime = undefined;
    this.showIcon = true;
  }
  componentDidLoad() {
    this.updateCountdown();
  }
  updateCountdown() {
    this.formattedTime = getFormattedRemainingTime();
    setInterval(() => {
      this.formattedTime = getFormattedRemainingTime();
    }, 1000);
  }
  render() {
    return (h(Host, { role: "timer", class: {
        'sc-upsell-countdown-timer': true,
      } }, this.showIcon && h("sc-icon", { name: "clock" }), h("span", null, h("slot", { name: "offer-expire-text" }), " ", h("strong", null, this.formattedTime))));
  }
  static get is() { return "sc-upsell-countdown-timer"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-upsell-countdown-timer.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-upsell-countdown-timer.css"]
    };
  }
  static get properties() {
    return {
      "showIcon": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Whether to show the icon."
        },
        "attribute": "show-icon",
        "reflect": false,
        "defaultValue": "true"
      }
    };
  }
  static get states() {
    return {
      "timeRemaining": {},
      "formattedTime": {}
    };
  }
}
//# sourceMappingURL=sc-upsell-countdown-timer.js.map
