/**
 * External dependencies.
 */
import { h, Host } from '@stencil/core';
/**
 * Internal dependencies.
 */
import { state as upsellState } from '@store/upsell';
import { state as noticesState } from '@store/notices';
import { isProductOutOfStock, isSelectedVariantMissing } from '@store/product/getters';
import { accept } from '@store/upsell/mutations';
import { isBusy } from '@store/upsell/getters';
export class ScUpsellSubmitButton {
  getUpsellProductId() {
    var _a;
    return ((_a = upsellState.product) === null || _a === void 0 ? void 0 : _a.id) || '';
  }
  async handleAddToOrderClick(e) {
    e.preventDefault();
    accept();
  }
  render() {
    return (h(Host, { class: {
        'is-busy': isBusy(),
        'is-disabled': upsellState.disabled,
        // TODO: change this to out of stock error message.
        'is-sold-out': (isProductOutOfStock(this.getUpsellProductId()) && !isSelectedVariantMissing(this.getUpsellProductId())) || (noticesState === null || noticesState === void 0 ? void 0 : noticesState.code) === 'out_of_stock',
        'is-unavailable': isSelectedVariantMissing(this.getUpsellProductId()) || (noticesState === null || noticesState === void 0 ? void 0 : noticesState.code) === 'expired',
      }, onClick: e => this.handleAddToOrderClick(e) }, h("slot", null)));
  }
  static get is() { return "sc-upsell-submit-button"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-upsell-submit-button.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-upsell-submit-button.css"]
    };
  }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=sc-upsell-submit-button.js.map
