/**
 * External dependencies.
 */
import { h } from '@stencil/core';
/**
 * This component checks to make sure there is an error component
 * and adds one if it's missing.
 */
export class ScFormErrorProvider {
  componentWillLoad() {
    this.maybeAddErrorsComponent();
  }
  maybeAddErrorsComponent() {
    var _a, _b;
    if (!!this.el.querySelector('sc-checkout-form-errors'))
      return;
    const errorsComponent = document.createElement('sc-checkout-form-errors');
    (_b = (_a = this.el.querySelector('sc-form')) === null || _a === void 0 ? void 0 : _a.prepend) === null || _b === void 0 ? void 0 : _b.call(_a, errorsComponent);
  }
  render() {
    return h("slot", null);
  }
  static get is() { return "sc-form-error-provider"; }
  static get encapsulation() { return "shadow"; }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=sc-form-error-provider.js.map
