import { h } from '@stencil/core';
export class ScBadgeNotice {
  constructor() {
    this.type = 'primary';
    this.label = undefined;
    this.size = 'small';
  }
  render() {
    return (h("div", { class: {
        'notice': true,
        'notice--is-small': this.size === 'small',
        'notice--is-medium': this.size === 'medium',
        'notice--is-large': this.size === 'large',
        'notice--primary': this.type === 'primary',
        'notice--success': this.type === 'success',
        'notice--warning': this.type === 'warning',
        'notice--danger': this.type === 'danger',
        'notice--default': this.type === 'default',
      } }, h("sc-tag", { size: this.size, type: this.type }, this.label), h("slot", null)));
  }
  static get is() { return "sc-badge-notice"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-badge-notice.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-badge-notice.css"]
    };
  }
  static get properties() {
    return {
      "type": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'primary' | 'success' | 'info' | 'warning' | 'danger' | 'default'",
          "resolved": "\"danger\" | \"default\" | \"info\" | \"primary\" | \"success\" | \"warning\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "type",
        "reflect": false,
        "defaultValue": "'primary'"
      },
      "label": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "label",
        "reflect": false
      },
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'small' | 'medium' | 'large'",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'small'"
      }
    };
  }
}
//# sourceMappingURL=sc-badge-notice.js.map
