import { h } from '@stencil/core';
/**
 * @part base - The elements base wrapper.
 * @part content - The content (spinner)
 */
export class ScBlockUi {
  constructor() {
    this.zIndex = 1;
    this.transparent = undefined;
    this.spinner = undefined;
  }
  render() {
    return (h("div", { part: "base", class: { overlay: true, transparent: this.transparent }, style: { 'z-index': this.zIndex.toString() } }, h("div", { class: "overlay__content", part: "content" }, h("slot", { name: "spinner" }, !this.transparent && this.spinner && h("sc-spinner", null)), h("slot", null))));
  }
  static get is() { return "sc-block-ui"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-block-ui.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-block-ui.css"]
    };
  }
  static get properties() {
    return {
      "zIndex": {
        "type": "number",
        "mutable": false,
        "complexType": {
          "original": "number",
          "resolved": "number",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "z-index",
        "reflect": false,
        "defaultValue": "1"
      },
      "transparent": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "transparent",
        "reflect": false
      },
      "spinner": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "spinner",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-block-ui.js.map
