import { h } from '@stencil/core';
/**
 * @part base - The elements base wrapper.
 */
export class ScCcLogo {
  constructor() {
    this.brand = undefined;
  }
  renderLogo() {
    if (['visa', 'mastercard', 'amex', 'discover', 'diners', 'jcb', 'unionpay'].includes(this.brand)) {
      return h("sc-icon", { name: this.brand, style: { '--height': '0.63em' } });
    }
    return h("sc-icon", { name: "creditcard", style: { '--height': '0.63em' } });
  }
  render() {
    return (h("div", { class: "cc-logo", part: "base" }, this.renderLogo()));
  }
  static get is() { return "sc-cc-logo"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-cc-logo.css"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-cc-logo.css"]
    };
  }
  static get properties() {
    return {
      "brand": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "brand",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-cc-logo.js.map
