import { Host, h } from '@stencil/core';
export class ScColumns {
  constructor() {
    this.verticalAlignment = undefined;
    this.isStackedOnMobile = undefined;
    this.isFullHeight = undefined;
    this.isReversedOnMobile = undefined;
  }
  render() {
    return (h(Host, { class: {
        'sc-columns': true,
        [`are-vertically-aligned-${this.verticalAlignment}`]: !!this.verticalAlignment,
        'is-not-stacked-on-mobile': !this.isStackedOnMobile,
        'is-full-height': !!this.isFullHeight,
        'is-reversed-on-mobile': !!this.isReversedOnMobile,
      } }, h("slot", null)));
  }
  static get is() { return "sc-columns"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-columns.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-columns.css"]
    };
  }
  static get properties() {
    return {
      "verticalAlignment": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The vertical alignment of the columns."
        },
        "attribute": "vertical-alignment",
        "reflect": false
      },
      "isStackedOnMobile": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Is this stacked on mobile"
        },
        "attribute": "is-stacked-on-mobile",
        "reflect": false
      },
      "isFullHeight": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Is this full vertical height"
        },
        "attribute": "is-full-height",
        "reflect": false
      },
      "isReversedOnMobile": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Is this reverse ordered on mobile"
        },
        "attribute": "is-reversed-on-mobile",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-columns.js.map
