import { h } from '@stencil/core';
/**
 * @part base - The elements base wrapper.
 * @part icon - The icon.
 */
export class ScEmpty {
  constructor() {
    this.icon = undefined;
  }
  render() {
    return (h("div", { part: "base", class: "empty" }, !!this.icon && h("sc-icon", { exportparts: "base:icon", name: this.icon }), h("slot", null)));
  }
  static get is() { return "sc-empty"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-empty.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-empty.css"]
    };
  }
  static get properties() {
    return {
      "icon": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "icon",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-empty.js.map
