import { h } from '@stencil/core';
export class ScHeading {
  constructor() {
    this.size = 'medium';
  }
  render() {
    return (h("div", { part: "base", class: {
        'heading': true,
        'heading--small': this.size === 'small',
        'heading--medium': this.size === 'medium',
        'heading--large': this.size === 'large',
      } }, h("div", { class: { heading__text: true } }, h("div", { class: "heading__title", part: "title" }, h("slot", null)), h("div", { class: "heading__description", part: "description" }, h("slot", { name: "description" }))), h("slot", { name: "end" })));
  }
  static get is() { return "sc-heading"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-heading.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-heading.css"]
    };
  }
  static get properties() {
    return {
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'small' | 'medium' | 'large'",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "size",
        "reflect": false,
        "defaultValue": "'medium'"
      }
    };
  }
  static get elementRef() { return "el"; }
}
//# sourceMappingURL=sc-heading.js.map
