import { h } from '@stencil/core';
export class ScPillOption {
  constructor() {
    this.isSelected = undefined;
    this.isUnavailable = undefined;
  }
  render() {
    return (h("button", { class: {
        'sc-pill-option__button': true,
        'sc-pill-option__button--disabled': this.isUnavailable,
        'sc-pill-option__button--selected': this.isSelected,
      }, tabindex: "0", role: "radio", "aria-checked": this.isSelected ? 'true' : 'false', "aria-disabled": this.isUnavailable ? 'true' : 'false' }, h("slot", null)));
  }
  static get is() { return "sc-pill-option"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-pill-option.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-pill-option.css"]
    };
  }
  static get properties() {
    return {
      "isSelected": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Label"
        },
        "attribute": "is-selected",
        "reflect": false
      },
      "isUnavailable": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "is-unavailable",
        "reflect": false
      }
    };
  }
}
//# sourceMappingURL=sc-pill-option.js.map
