import { h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
export class ScFeatureDemoBanner {
  constructor() {
    this.url = 'https://app.surecart.com/billing';
    this.buttonText = __('Upgrade Your Plan', 'surecart');
  }
  render() {
    return (h("div", { class: { 'sc-banner': true } }, h("p", null, h("slot", null, __('This is a feature demo. In order to use it, you must upgrade your plan.', 'surecart')), h("a", { href: this.url, target: "_blank" }, h("slot", { name: "link" }, this.buttonText, " ", h("sc-icon", { name: "arrow-right" }))))));
  }
  static get is() { return "sc-feature-demo-banner"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-feature-demo-banner.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-feature-demo-banner.css"]
    };
  }
  static get properties() {
    return {
      "url": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "url",
        "reflect": false,
        "defaultValue": "'https://app.surecart.com/billing'"
      },
      "buttonText": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "string",
          "resolved": "string",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "button-text",
        "reflect": false,
        "defaultValue": "__('Upgrade Your Plan', 'surecart')"
      }
    };
  }
}
//# sourceMappingURL=sc-feature-demo-banner.js.map
