import { h } from '@stencil/core';
import { __ } from '@wordpress/i18n';
export class ScPremiumTag {
  constructor() {
    this.size = 'small';
  }
  render() {
    return (h("sc-tag", { type: "success", size: this.size }, __('Premium', 'surecart')));
  }
  static get is() { return "sc-premium-tag"; }
  static get encapsulation() { return "shadow"; }
  static get properties() {
    return {
      "size": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'small' | 'medium' | 'large'",
          "resolved": "\"large\" | \"medium\" | \"small\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "The tag's size."
        },
        "attribute": "size",
        "reflect": true,
        "defaultValue": "'small'"
      }
    };
  }
}
//# sourceMappingURL=sc-premium-tag.js.map
