import { h } from '@stencil/core';
export class ScSkeleton {
  constructor() {
    this.effect = 'sheen';
  }
  render() {
    return (h("div", { part: "base", class: {
        'skeleton': true,
        'skeleton--pulse': this.effect === 'pulse',
        'skeleton--sheen': this.effect === 'sheen',
      }, "aria-busy": "true", "aria-live": "polite" }, h("div", { part: "indicator", class: "skeleton__indicator" })));
  }
  static get is() { return "sc-skeleton"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-skeleton.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-skeleton.css"]
    };
  }
  static get properties() {
    return {
      "effect": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'pulse' | 'sheen' | 'none'",
          "resolved": "\"none\" | \"pulse\" | \"sheen\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": "Animation effect"
        },
        "attribute": "effect",
        "reflect": false,
        "defaultValue": "'sheen'"
      }
    };
  }
}
//# sourceMappingURL=sc-skeleton.js.map
