import { h } from '@stencil/core';
import { isRtl } from '../../../functions/page-align';
export class ScText {
  constructor() {
    this.tag = 'p';
    this.truncate = false;
  }
  render() {
    const CustomTag = this.tag;
    return (h(CustomTag, { class: {
        'text': true,
        'is-truncated': this.truncate,
        'text--is-rtl': isRtl()
      } }, h("slot", null)));
  }
  static get is() { return "sc-text"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() {
    return {
      "$": ["sc-text.scss"]
    };
  }
  static get styleUrls() {
    return {
      "$": ["sc-text.css"]
    };
  }
  static get properties() {
    return {
      "tag": {
        "type": "string",
        "mutable": false,
        "complexType": {
          "original": "'h1' | 'h2' | 'h3' | 'h4' | 'h5' | 'h6' | 'p'",
          "resolved": "\"h1\" | \"h2\" | \"h3\" | \"h4\" | \"h5\" | \"h6\" | \"p\"",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "tag",
        "reflect": false,
        "defaultValue": "'p'"
      },
      "truncate": {
        "type": "boolean",
        "mutable": false,
        "complexType": {
          "original": "boolean",
          "resolved": "boolean",
          "references": {}
        },
        "required": false,
        "optional": false,
        "docs": {
          "tags": [],
          "text": ""
        },
        "attribute": "truncate",
        "reflect": false,
        "defaultValue": "false"
      }
    };
  }
}
//# sourceMappingURL=sc-text.js.map
