/**
 * Get any additional error messages.
 */
export const getAdditionalErrorMessages = error => ((error === null || error === void 0 ? void 0 : error.additional_errors) || []).map(error => error.message);
/**
 * Get the top level error
 */
export const getTopLevelError = (error) => {
  var _a;
  // checkout invalid is not friendly.
  if ((error === null || error === void 0 ? void 0 : error.code) === 'checkout.invalid' && ((_a = getAdditionalErrorMessages(error)) === null || _a === void 0 ? void 0 : _a.length)) {
    return '';
  }
  return error === null || error === void 0 ? void 0 : error.message;
};
//# sourceMappingURL=error.js.map
