var _a, _b, _c, _d, _e, _f, _g;
import apiFetch from '@wordpress/api-fetch';
import { __ } from '@wordpress/i18n';
import { addQueryArgs } from '@wordpress/url';
apiFetch.fetchAllMiddleware = null;
apiFetch.use(apiFetch.createRootURLMiddleware(((_b = (_a = window === null || window === void 0 ? void 0 : window.parent) === null || _a === void 0 ? void 0 : _a.scData) === null || _b === void 0 ? void 0 : _b.root_url) || ((_c = window === null || window === void 0 ? void 0 : window.scData) === null || _c === void 0 ? void 0 : _c.root_url)));
if ((_d = window === null || window === void 0 ? void 0 : window.scData) === null || _d === void 0 ? void 0 : _d.nonce) {
  // @ts-ignore
  apiFetch.nonceMiddleware = apiFetch.createNonceMiddleware((_e = window === null || window === void 0 ? void 0 : window.scData) === null || _e === void 0 ? void 0 : _e.nonce);
  // @ts-ignore
  apiFetch.use(apiFetch.nonceMiddleware);
}
if ((_f = window === null || window === void 0 ? void 0 : window.scData) === null || _f === void 0 ? void 0 : _f.nonce_endpoint) {
  // @ts-ignore
  apiFetch.nonceEndpoint = (_g = window === null || window === void 0 ? void 0 : window.scData) === null || _g === void 0 ? void 0 : _g.nonce_endpoint;
}
// Add a timestamp so it can bypass cache rest api
apiFetch.use((options, next) => {
  options.path = addQueryArgs(options.path, { t: Date.now() });
  return next(options);
});
export default apiFetch;
/**
 * Calls the `json` function on the Response, throwing an error if the response
 * doesn't have a json function or if parsing the json itself fails.
 *
 * @param {Response} response
 * @return {Promise<any>} Parsed response.
 */
export const parseJsonAndNormalizeError = response => {
  const invalidJsonError = {
    code: 'invalid_json',
    message: __('The response is not a valid JSON response.', 'surecart'),
  };
  if ((response === null || response === void 0 ? void 0 : response.code) && (response === null || response === void 0 ? void 0 : response.message)) {
    throw response;
  }
  if (!response || !response.json) {
    throw invalidJsonError;
  }
  return response.json().catch(() => {
    throw invalidJsonError;
  });
};
export const handleNonceError = async (response) => {
  // need to parse the error response since we are bypassing the apiFetch middleware.
  const error = await parseJsonAndNormalizeError(response);
  if (error.code !== 'rest_cookie_invalid_nonce') {
    // console.error(error);
    throw error;
  }
  // If the nonce is invalid, refresh it and try again.
  return (window
    // @ts-ignore
    .fetch(apiFetch.nonceEndpoint)
    .then(response => {
    if (response.status >= 200 && response.status < 300) {
      return response;
    }
    throw response;
  })
    .then(data => data.text())
    .then(text => {
    // @ts-ignore
    apiFetch.nonceMiddleware.nonce = text;
  }));
};
//# sourceMappingURL=fetch.js.map
