export function getMaxStockQuantity(product, selectedVariant) {
  // Check purchase limit.
  if (product === null || product === void 0 ? void 0 : product.purchase_limit) {
    return product === null || product === void 0 ? void 0 : product.purchase_limit;
  }
  // Check if stock needs to be checked
  const isStockNeedsToBeChecked = !!((product === null || product === void 0 ? void 0 : product.stock_enabled) && !(product === null || product === void 0 ? void 0 : product.allow_out_of_stock_purchases));
  // If stock is not enabled, return null
  if (!isStockNeedsToBeChecked) {
    return null;
  }
  // If no variant is selected, check against product stock.
  if (!selectedVariant)
    return product === null || product === void 0 ? void 0 : product.available_stock;
  // Check against selected variant's stock.
  return selectedVariant === null || selectedVariant === void 0 ? void 0 : selectedVariant.available_stock;
}
//# sourceMappingURL=quantity.js.map
