import { maybeConvertAmount } from 'src/functions/currency';
/**
 * Handle add to cart event.
 */
window.addEventListener('scAddedToCart', function (e) {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  // get the added item from the event.
  const item = e.detail;
  // sanity check.
  if (!((_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product))
    return;
  const product = (_b = item === null || item === void 0 ? void 0 : item.price) === null || _b === void 0 ? void 0 : _b.product;
  const productCollections = ((_d = (_c = product === null || product === void 0 ? void 0 : product.product_collections) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.map(collection => collection.name)) || [];
  window.fbq('track', 'AddToCart', {
    ...(productCollections.length ? { content_category: productCollections.join(', ') } : {}),
    content_ids: [product.id],
    content_name: (product === null || product === void 0 ? void 0 : product.name) + (((_e = item === null || item === void 0 ? void 0 : item.variant_options) === null || _e === void 0 ? void 0 : _e.length) ? ` - ${item === null || item === void 0 ? void 0 : item.variant_options.join(' / ')}` : ''),
    content_type: 'product',
    contents: [
      {
        id: product.id,
        quantity: item.quantity,
      },
    ],
    currency: (_f = item === null || item === void 0 ? void 0 : item.price) === null || _f === void 0 ? void 0 : _f.currency,
    value: maybeConvertAmount(((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.amount) || 0, ((_h = item === null || item === void 0 ? void 0 : item.price) === null || _h === void 0 ? void 0 : _h.currency) || 'USD'),
  });
});
/**
 * Handle purchase initiated event.
 */
window.addEventListener('scCheckoutInitiated', function (e) {
  var _a, _b, _c, _d;
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const checkout = e.detail;
  window.fbq('track', 'InitiateCheckout', {
    content_ids: (_a = ((checkout === null || checkout === void 0 ? void 0 : checkout.line_items.data) || [])) === null || _a === void 0 ? void 0 : _a.map(item => item.id),
    contents: (_b = ((checkout === null || checkout === void 0 ? void 0 : checkout.line_items.data) || [])) === null || _b === void 0 ? void 0 : _b.map(item => ({ id: item.id, quantity: item.quantity })),
    currency: checkout === null || checkout === void 0 ? void 0 : checkout.currency,
    num_items: ((_d = (_c = checkout === null || checkout === void 0 ? void 0 : checkout.line_items) === null || _c === void 0 ? void 0 : _c.data) === null || _d === void 0 ? void 0 : _d.length) || 0,
    value: maybeConvertAmount(checkout === null || checkout === void 0 ? void 0 : checkout.total_amount, (checkout === null || checkout === void 0 ? void 0 : checkout.currency) || 'USD'),
  });
});
/**
 * Handle purchase complete event.
 */
window.addEventListener('scCheckoutCompleted', function (e) {
  var _a, _b, _c;
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const checkout = e.detail;
  window.fbq('track', 'Purchase', {
    content_ids: (_a = checkout === null || checkout === void 0 ? void 0 : checkout.items) === null || _a === void 0 ? void 0 : _a.map(item => item.item_id),
    content_name: 'Purchase',
    content_type: 'product',
    contents: (_b = checkout === null || checkout === void 0 ? void 0 : checkout.items) === null || _b === void 0 ? void 0 : _b.map(item => ({ id: item.item_id, quantity: item.quantity })),
    currency: checkout === null || checkout === void 0 ? void 0 : checkout.currency,
    num_items: (_c = checkout === null || checkout === void 0 ? void 0 : checkout.items) === null || _c === void 0 ? void 0 : _c.length,
    value: maybeConvertAmount(checkout === null || checkout === void 0 ? void 0 : checkout.total_amount, (checkout === null || checkout === void 0 ? void 0 : checkout.currency) || 'USD'),
  });
});
/**
 * Handle trial started event.
 */
window.addEventListener('scTrialStarted', function (e) {
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const items = e.detail;
  items.forEach(item => {
    var _a, _b, _c;
    window.fbq('track', 'StartTrial', {
      currency: (_a = item.price) === null || _a === void 0 ? void 0 : _a.currency,
      value: maybeConvertAmount(((_b = item.price) === null || _b === void 0 ? void 0 : _b.amount) || 0, ((_c = item.price) === null || _c === void 0 ? void 0 : _c.currency) || 'USD'),
    });
  });
});
/**
 * Handle subscription started event.
 */
window.addEventListener('scSubscriptionStarted', function (e) {
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const items = e.detail;
  items.forEach(item => {
    var _a, _b, _c;
    window.fbq('track', 'Subscribe', {
      currency: (_a = item.price) === null || _a === void 0 ? void 0 : _a.currency,
      value: maybeConvertAmount(((_b = item.price) === null || _b === void 0 ? void 0 : _b.amount) || 0, ((_c = item.price) === null || _c === void 0 ? void 0 : _c.currency) || 'USD'),
    });
  });
});
/**
 * Handle payment info added event.
 */
window.addEventListener('scPaymentInfoAdded', function (e) {
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const detail = e.detail;
  window.fbq('track', 'AddPaymentInfo', {
    content_category: 'Payment Info Added',
    currency: detail === null || detail === void 0 ? void 0 : detail.currency,
  });
});
//# sourceMappingURL=facebook.js.map
