import { getCheckout } from '../checkouts/mutations';
import state from './store';
/**
 * Gets the current checkout for the page.
 */
export const currentCheckout = () => getCheckout(state.formId, state.mode);
/**
 * Is the checkout currently locked.
 * Pass an optional lock name to find if a
 * specific lock name is locking checkout.
 */
export const checkoutIsLocked = (lockName = '') => { var _a; return (lockName ? state.locks.some(name => name === lockName) : !!((_a = state.locks) === null || _a === void 0 ? void 0 : _a.length)); };
/**
 * Get a line item by product id.
 */
export const getLineItemByProductId = (productId) => { var _a, _b; return (((_b = (_a = state.checkout) === null || _a === void 0 ? void 0 : _a.line_items) === null || _b === void 0 ? void 0 : _b.data) || []).find(line_item => { var _a, _b; return ((_b = (_a = line_item === null || line_item === void 0 ? void 0 : line_item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id) === productId; }); };
/**
 * Is the shipping address required?
 */
export const fullShippingAddressRequired = () => { var _a, _b; return ((_a = state.checkout) === null || _a === void 0 ? void 0 : _a.shipping_enabled) || ((_b = state === null || state === void 0 ? void 0 : state.checkout) === null || _b === void 0 ? void 0 : _b.shipping_address_required); };
/**
 * Is the address required?
 */
export const shippingAddressRequired = () => { var _a, _b, _c, _d; return ((_a = state.checkout) === null || _a === void 0 ? void 0 : _a.tax_status) === 'address_invalid' || ((_b = state.checkout) === null || _b === void 0 ? void 0 : _b.shipping_enabled) || ((_c = state.checkout) === null || _c === void 0 ? void 0 : _c.shipping_address_required) || ((_d = state === null || state === void 0 ? void 0 : state.checkout) === null || _d === void 0 ? void 0 : _d.tax_enabled); };
//# sourceMappingURL=getters.js.map
