import { trackEvent } from 'src/functions/google';
import { maybeConvertAmount } from '../../functions/currency';
/**
 * Handle add to cart event.
 */
window.addEventListener('scAddedToCart', (e) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
  const item = e.detail;
  // sanity check.
  if (!((_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product))
    return;
  trackEvent('add_to_cart', {
    currency: (_b = item.price) === null || _b === void 0 ? void 0 : _b.currency,
    value: maybeConvertAmount(((_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.amount) || 0, ((_d = item.price) === null || _d === void 0 ? void 0 : _d.currency) || 'USD'),
    items: [
      {
        item_id: (_f = (_e = item.price) === null || _e === void 0 ? void 0 : _e.product) === null || _f === void 0 ? void 0 : _f.id,
        item_name: (_h = (_g = item.price) === null || _g === void 0 ? void 0 : _g.product) === null || _h === void 0 ? void 0 : _h.name,
        item_variant: (item.variant_options || []).join(' / '),
        price: maybeConvertAmount(((_j = item === null || item === void 0 ? void 0 : item.price) === null || _j === void 0 ? void 0 : _j.amount) || 0, ((_k = item.price) === null || _k === void 0 ? void 0 : _k.currency) || 'USD'),
        currency: (_l = item.price) === null || _l === void 0 ? void 0 : _l.currency,
        quantity: item.quantity,
        discount: (item === null || item === void 0 ? void 0 : item.discount_amount) ? maybeConvertAmount((item === null || item === void 0 ? void 0 : item.discount_amount) || 0, ((_m = item.price) === null || _m === void 0 ? void 0 : _m.currency) || 'USD') : 0,
      },
    ],
  });
});
/**
 * Handle remove from cart event.
 */
window.addEventListener('scRemovedFromCart', (e) => {
  var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
  const item = e.detail;
  // sanity check.
  if (!((_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product))
    return;
  trackEvent('remove_from_cart', {
    currency: (_b = item.price) === null || _b === void 0 ? void 0 : _b.currency,
    value: maybeConvertAmount(((_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.amount) || 0, ((_d = item.price) === null || _d === void 0 ? void 0 : _d.currency) || 'USD'),
    items: [
      {
        item_id: (_f = (_e = item.price) === null || _e === void 0 ? void 0 : _e.product) === null || _f === void 0 ? void 0 : _f.id,
        item_name: (_h = (_g = item.price) === null || _g === void 0 ? void 0 : _g.product) === null || _h === void 0 ? void 0 : _h.name,
        item_variant: (item.variant_options || []).join(' / '),
        price: maybeConvertAmount(((_j = item === null || item === void 0 ? void 0 : item.price) === null || _j === void 0 ? void 0 : _j.amount) || 0, ((_k = item.price) === null || _k === void 0 ? void 0 : _k.currency) || 'USD'),
        currency: (_l = item.price) === null || _l === void 0 ? void 0 : _l.currency,
        quantity: item.quantity,
        discount: (item === null || item === void 0 ? void 0 : item.discount_amount) ? maybeConvertAmount((item === null || item === void 0 ? void 0 : item.discount_amount) || 0, ((_m = item.price) === null || _m === void 0 ? void 0 : _m.currency) || 'USD') : 0,
      },
    ],
  });
});
/**
 * Handle view cart event.
 */
window.addEventListener('scViewedCart', (e) => {
  var _a;
  const checkout = e.detail;
  trackEvent('view_cart', {
    currency: checkout.currency,
    value: maybeConvertAmount(checkout.total_amount, checkout.currency),
    items: (((_a = checkout.line_items) === null || _a === void 0 ? void 0 : _a.data) || []).map(item => {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j;
      return ({
        item_id: (_b = (_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id,
        item_name: (_d = (_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.name,
        currency: (_e = item.price) === null || _e === void 0 ? void 0 : _e.currency,
        discount: item.discount_amount ? maybeConvertAmount(item.discount_amount, (_f = item.price) === null || _f === void 0 ? void 0 : _f.currency) : 0,
        price: maybeConvertAmount((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.amount, (_h = item.price) === null || _h === void 0 ? void 0 : _h.currency),
        quantity: item.quantity,
        ...(((_j = item === null || item === void 0 ? void 0 : item.variant_options) === null || _j === void 0 ? void 0 : _j.length) ? { item_variant: (item.variant_options || []).join(' / ') } : {}),
      });
    }),
  });
});
/**
 * Handle checkout initiated event.
 */
window.addEventListener('scCheckoutInitiated', (e) => {
  var _a;
  const checkout = e.detail;
  trackEvent('begin_checkout', {
    currency: checkout.currency,
    value: maybeConvertAmount(checkout.total_amount, checkout.currency),
    items: (((_a = checkout.line_items) === null || _a === void 0 ? void 0 : _a.data) || []).map(item => {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j;
      return ({
        item_id: (_b = (_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id,
        item_name: (_d = (_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.name,
        currency: (_e = item.price) === null || _e === void 0 ? void 0 : _e.currency,
        discount: item.discount_amount ? maybeConvertAmount(item.discount_amount, (_f = item.price) === null || _f === void 0 ? void 0 : _f.currency) : 0,
        price: maybeConvertAmount((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.amount, (_h = item.price) === null || _h === void 0 ? void 0 : _h.currency),
        quantity: item.quantity,
        ...(((_j = item === null || item === void 0 ? void 0 : item.variant_options) === null || _j === void 0 ? void 0 : _j.length) ? { item_variant: (item.variant_options || []).join(' / ') } : {}),
      });
    }),
  });
});
/**
 * Handle purchase complete event.
 */
window.addEventListener('scCheckoutCompleted', (e) => {
  var _a;
  const checkout = e.detail;
  trackEvent('purchase', {
    transaction_id: checkout === null || checkout === void 0 ? void 0 : checkout.id,
    value: maybeConvertAmount(checkout === null || checkout === void 0 ? void 0 : checkout.total_amount, (checkout === null || checkout === void 0 ? void 0 : checkout.currency) || 'USD'),
    currency: (checkout.currency || '').toUpperCase(),
    items: (((_a = checkout === null || checkout === void 0 ? void 0 : checkout.line_items) === null || _a === void 0 ? void 0 : _a.data) || []).map(item => {
      var _a, _b, _c, _d, _e, _f, _g, _h;
      return ({
        item_id: (_b = (_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id,
        currency: (checkout.currency || '').toUpperCase(),
        item_name: ((_d = (_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.name) || '',
        discount: (item === null || item === void 0 ? void 0 : item.discount_amount) ? maybeConvertAmount((item === null || item === void 0 ? void 0 : item.discount_amount) || 0, ((_e = item === null || item === void 0 ? void 0 : item.price) === null || _e === void 0 ? void 0 : _e.currency) || 'USD') : 0,
        price: maybeConvertAmount(((_f = item === null || item === void 0 ? void 0 : item.price) === null || _f === void 0 ? void 0 : _f.amount) || 0, ((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.currency) || 'USD'),
        quantity: (item === null || item === void 0 ? void 0 : item.quantity) || 1,
        ...(((_h = item === null || item === void 0 ? void 0 : item.variant_options) === null || _h === void 0 ? void 0 : _h.length) ? { item_variant: (item.variant_options || []).join(' / ') } : {}),
      });
    }),
  });
});
/**
 * Handle payment info added event.
 */
window.addEventListener('scPaymentInfoAdded', (e) => {
  var _a;
  const checkout = e.detail;
  trackEvent('add_payment_info', {
    currency: checkout.currency,
    value: maybeConvertAmount(checkout.total_amount, checkout.currency),
    items: (((_a = checkout.line_items) === null || _a === void 0 ? void 0 : _a.data) || []).map(item => {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j;
      return ({
        item_id: (_b = (_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id,
        item_name: ((_d = (_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.name) || '',
        currency: (_e = item.price) === null || _e === void 0 ? void 0 : _e.currency,
        discount: item.discount_amount ? maybeConvertAmount(item.discount_amount, (_f = item.price) === null || _f === void 0 ? void 0 : _f.currency) : 0,
        price: maybeConvertAmount((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.amount, (_h = item.price) === null || _h === void 0 ? void 0 : _h.currency),
        quantity: item.quantity,
        ...(((_j = item === null || item === void 0 ? void 0 : item.variant_options) === null || _j === void 0 ? void 0 : _j.length) ? { item_variant: (item.variant_options || []).join(' / ') } : {}),
      });
    }),
  });
});
/**
 * Handle shipping info added event.
 */
window.addEventListener('scShippingInfoAdded', (e) => {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  const checkout = e.detail;
  const selectedShippingChoice = (_b = (_a = checkout === null || checkout === void 0 ? void 0 : checkout.shipping_choices) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.find(method => method.id === (checkout === null || checkout === void 0 ? void 0 : checkout.selected_shipping_choice));
  const selectedShippingTier = ((_c = selectedShippingChoice === null || selectedShippingChoice === void 0 ? void 0 : selectedShippingChoice.shipping_method) === null || _c === void 0 ? void 0 : _c.name) || '';
  trackEvent('add_shipping_info', {
    currency: checkout.currency,
    value: maybeConvertAmount(checkout.total_amount, checkout.currency),
    ...(((_e = (_d = checkout === null || checkout === void 0 ? void 0 : checkout.discount) === null || _d === void 0 ? void 0 : _d.promotion) === null || _e === void 0 ? void 0 : _e.code) ? { coupon: (_g = (_f = checkout === null || checkout === void 0 ? void 0 : checkout.discount) === null || _f === void 0 ? void 0 : _f.promotion) === null || _g === void 0 ? void 0 : _g.code } : {}),
    ...(selectedShippingTier ? { shipping_tier: selectedShippingTier } : ''),
    items: (((_h = checkout.line_items) === null || _h === void 0 ? void 0 : _h.data) || []).map(item => {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j;
      return ({
        item_id: (_b = (_a = item === null || item === void 0 ? void 0 : item.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.id,
        item_name: ((_d = (_c = item === null || item === void 0 ? void 0 : item.price) === null || _c === void 0 ? void 0 : _c.product) === null || _d === void 0 ? void 0 : _d.name) || '',
        currency: (_e = item.price) === null || _e === void 0 ? void 0 : _e.currency,
        discount: item.discount_amount ? maybeConvertAmount(item.discount_amount, (_f = item.price) === null || _f === void 0 ? void 0 : _f.currency) : 0,
        price: maybeConvertAmount((_g = item === null || item === void 0 ? void 0 : item.price) === null || _g === void 0 ? void 0 : _g.amount, (_h = item.price) === null || _h === void 0 ? void 0 : _h.currency),
        quantity: item.quantity,
        ...(((_j = item === null || item === void 0 ? void 0 : item.variant_options) === null || _j === void 0 ? void 0 : _j.length) ? { item_variant: (item.variant_options || []).join(' / ') } : {}),
      });
    }),
  });
});
//# sourceMappingURL=google.js.map
