import { createStore } from '@stencil/store';
import { getSerializedState } from '@store/utils';
const { checkout } = getSerializedState();
const { state, onChange, on, set, get, dispose } = createStore({
  formId: null,
  groupId: null,
  mode: 'live',
  locks: [],
  product: null,
  checkout: null,
  currencyCode: 'usd',
  abandonedCheckoutEnabled: true,
  initialLineItems: [],
  isCheckoutPage: false,
  validateStock: false,
  persist: 'browser',
  ...checkout,
}, (newValue, oldValue) => {
  return JSON.stringify(newValue) !== JSON.stringify(oldValue);
});
export default state;
export { state, onChange, on, set, get, dispose };
//# sourceMappingURL=store.js.map
