import store from './store';
import { state as checkoutState } from '@store/checkout';
import { addQueryArgs, removeQueryArgs } from '@wordpress/url';
/** Get the checkout. */
export const getCheckout = (formId, mode) => { var _a; return ((_a = store.state[mode]) === null || _a === void 0 ? void 0 : _a[formId]) || {}; };
/** Set the checkout. */
export const setCheckout = (data, formId) => {
  const mode = (data === null || data === void 0 ? void 0 : data.live_mode) ? 'live' : 'test';
  store.set(mode, { ...store.state[mode], [formId]: data });
  // update the current checkout state.
  if (checkoutState.formId === formId && checkoutState.mode === mode) {
    checkoutState.checkout = data;
  }
  // set in url only if we are not persisting the cart.
  if (checkoutState.persist === 'url' && (data === null || data === void 0 ? void 0 : data.id)) {
    window.history.replaceState({}, document.title, addQueryArgs(window.location.href, { checkout_id: data === null || data === void 0 ? void 0 : data.id }));
  }
};
/** Clear the order from the store. */
export const clearCheckout = (formId, mode) => {
  const { [formId]: remove, ...checkouts } = store.state[mode];
  window.history.replaceState({}, document.title, removeQueryArgs(window.location.href, 'redirect_status', 'coupon', 'line_items', 'confirm_checkout_id', 'checkout_id'));
  return store.set(mode, checkouts);
};
//# sourceMappingURL=mutations.js.map
