import { createLocalStore } from '../local';
import { createStore } from '@stencil/store';
import { getSerializedState } from '@store/utils';
import { getQueryArg } from '@wordpress/url';
const { checkout } = getSerializedState();
const notPersistCart = (checkout === null || checkout === void 0 ? void 0 : checkout.persist) !== 'browser' || !!getQueryArg(window.location.href, 'no_cart');
const store = notPersistCart
  ? createStore({
    live: {},
    test: {},
  })
  : createLocalStore('surecart-local-storage', {
    live: {},
    test: {},
  }, true);
const { state, onChange, on, set, get, dispose } = store;
window.scStore = store;
export default store;
export { state, onChange, on, set, get, dispose };
//# sourceMappingURL=store.js.map
