import { createStore } from '@stencil/store';
import { getSerializedState } from '@store/utils';
const { processors } = getSerializedState();
const { state, onChange, on, dispose } = createStore({
  processors: [],
  methods: [],
  manualPaymentMethods: [],
  disabled: {
    processors: [],
  },
  sortOrder: {
    processors: ['stripe', 'paystack', 'paypal'],
    manualPaymentMethods: [],
    paymentMethods: {
      mollie: ['creditcard', 'paypal'],
    },
  },
  config: {
    stripe: {
      paymentElement: false,
    },
  },
  ...processors,
}, (newValue, oldValue) => {
  return JSON.stringify(newValue) !== JSON.stringify(oldValue);
});
export default state;
export { state, onChange, on, dispose };
//# sourceMappingURL=store.js.map
