import { createStore } from '@stencil/store';
import { getSerializedState } from '@store/utils';
import { getLineItemByProductId } from '@store/checkout/getters';
const { productDonation } = getSerializedState();
// This gets initial checkout line items and updates the product donation store to match on load.
const productDonationData = Object.keys(productDonation || {}).reduce((acc, productId) => {
  var _a;
  const lineItem = getLineItemByProductId(productId);
  if (lineItem === null || lineItem === void 0 ? void 0 : lineItem.id) {
    acc[productId] = {
      ...acc[productId],
      ...((lineItem === null || lineItem === void 0 ? void 0 : lineItem.ad_hoc_amount) ? { ad_hoc_amount: lineItem.ad_hoc_amount } : {}),
      ...((lineItem === null || lineItem === void 0 ? void 0 : lineItem.price) ? { selectedPrice: lineItem.price } : {}),
      custom_amount: ((_a = (acc[productId].amounts || [])) === null || _a === void 0 ? void 0 : _a.includes(lineItem.ad_hoc_amount)) ? null : lineItem.ad_hoc_amount,
    };
  }
  return acc;
}, productDonation);
const { state, onChange, on, set, get, dispose } = createStore({ ...productDonationData }, (newValue, oldValue) => {
  return JSON.stringify(newValue) !== JSON.stringify(oldValue);
});
export default state;
export { state, onChange, on, set, get, dispose };
//# sourceMappingURL=store.js.map
