/**
 * Product viewed event.
 */
export const productViewed = (product, selectedPrice, quantity = 1) => {
  var _a;
  const event = new CustomEvent('scProductViewed', {
    detail: {
      id: product === null || product === void 0 ? void 0 : product.id,
      name: product === null || product === void 0 ? void 0 : product.name,
      price: selectedPrice,
      permalink: product === null || product === void 0 ? void 0 : product.permalink,
      prices: product === null || product === void 0 ? void 0 : product.prices,
      variant_options: (_a = product === null || product === void 0 ? void 0 : product.variant_options) === null || _a === void 0 ? void 0 : _a.data,
      product_collections: product === null || product === void 0 ? void 0 : product.product_collections,
      quantity,
    },
    bubbles: true,
  });
  document.dispatchEvent(event);
};
//# sourceMappingURL=events.js.map
