import { maybeConvertAmount } from 'src/functions/currency';
/**
 * Handle search event.
 */
window.addEventListener('scSearched', function (e) {
  var _a;
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const eventDetail = e.detail;
  window.fbq('track', 'Search', {
    search_string: eventDetail.searchString,
    content_ids: eventDetail.searchResultIds,
    ...(!!((_a = eventDetail === null || eventDetail === void 0 ? void 0 : eventDetail.searchCollections) === null || _a === void 0 ? void 0 : _a.length) ? { content_category: eventDetail.searchCollections.join(',') } : {}),
  });
});
/**
 * Handle view content event.
 */
window.addEventListener('scProductViewed', function (e) {
  var _a, _b, _c, _d, _e, _f;
  if (!(window === null || window === void 0 ? void 0 : window.fbq))
    return;
  const product = e.detail;
  window.fbq('track', 'ViewContent', {
    content_ids: [product.id],
    content_category: (_b = (_a = product === null || product === void 0 ? void 0 : product.product_collections) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.map(collection => collection.name).join(', '),
    content_name: (product === null || product === void 0 ? void 0 : product.name) + (((_c = product === null || product === void 0 ? void 0 : product.variant_options) === null || _c === void 0 ? void 0 : _c.length) ? ` - ${product === null || product === void 0 ? void 0 : product.variant_options.join(' / ')}` : ''),
    content_type: 'product',
    contents: [
      {
        id: product.id,
        quantity: 1,
      },
    ],
    currency: (_d = product === null || product === void 0 ? void 0 : product.price) === null || _d === void 0 ? void 0 : _d.currency,
    value: maybeConvertAmount(((_e = product.price) === null || _e === void 0 ? void 0 : _e.amount) || 0, ((_f = product.price) === null || _f === void 0 ? void 0 : _f.currency) || 'USD'),
  });
});
//# sourceMappingURL=facebook.js.map
