/**
 * External dependencies.
 */
import { getSerializedState } from '@store/utils';
import { createStore } from '@stencil/store';
/**
 * Get upsell from serialized state.
 */
const { upsell } = getSerializedState();
const store = createStore({
  upsell: null,
  product: null,
  line_item: null,
  checkout_id: null,
  checkout: null,
  form_id: null,
  busy: false,
  disabled: false,
  success_url: null,
  text: {
    success: {
      title: '',
      description: '',
      button: '',
    },
  },
  ...upsell,
}, (newValue, oldValue) => {
  return JSON.stringify(newValue) !== JSON.stringify(oldValue);
});
const { state, onChange, on, dispose, forceUpdate } = store;
export default state;
export { state, onChange, on, dispose, forceUpdate };
//# sourceMappingURL=store.js.map
