import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { f as formBusy } from './getters3.js';
import { d as defineCustomElement$4 } from './sc-button2.js';
import { d as defineCustomElement$3 } from './sc-icon2.js';
import { d as defineCustomElement$2 } from './sc-spinner2.js';

const scCartFormSubmitCss = "sc-order-submit{display:block;width:auto}";

const ScCartFormSubmit$1 = /*@__PURE__*/ proxyCustomElement(class ScCartFormSubmit extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.type = 'primary';
    this.size = 'medium';
    this.full = true;
    this.icon = undefined;
  }
  render() {
    return (h("sc-button", { submit: true, type: this.type, size: this.size, full: this.full, loading: formBusy(), disabled: formBusy() }, !!this.icon && h("sc-icon", { name: this.icon, slot: "prefix" }), h("slot", null)));
  }
  static get style() { return scCartFormSubmitCss; }
}, [4, "sc-cart-form-submit", {
    "type": [513],
    "size": [513],
    "full": [4],
    "icon": [1]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-cart-form-submit", "sc-button", "sc-icon", "sc-spinner"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-cart-form-submit":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScCartFormSubmit$1);
      }
      break;
    case "sc-button":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-spinner":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScCartFormSubmit = ScCartFormSubmit$1;
const defineCustomElement = defineCustomElement$1;

export { ScCartFormSubmit, defineCustomElement };

//# sourceMappingURL=sc-cart-form-submit.js.map