import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { s as state } from './mutations2.js';

const scCartLoaderCss = ":host{position:absolute;z-index:var(--sc-cart-z-index, 999999);font-family:var(--sc-font-sans)}";

const ScCartLoader$1 = /*@__PURE__*/ proxyCustomElement(class ScCartLoader extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.template = undefined;
  }
  render() {
    var _a;
    // check for forms.
    if (document.querySelector('sc-checkout')) {
      return;
    }
    // clear the order if it's already paid.
    if (((_a = state === null || state === void 0 ? void 0 : state.checkout) === null || _a === void 0 ? void 0 : _a.status) === 'paid') {
      state.checkout = null;
      return null;
    }
    // return the loader.
    return h("div", { innerHTML: this.template || '' });
  }
  static get style() { return scCartLoaderCss; }
}, [0, "sc-cart-loader", {
    "template": [1]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-cart-loader"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-cart-loader":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScCartLoader$1);
      }
      break;
  } });
}

const ScCartLoader = ScCartLoader$1;
const defineCustomElement = defineCustomElement$1;

export { ScCartLoader, defineCustomElement };

//# sourceMappingURL=sc-cart-loader.js.map