import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { d as defineCustomElement$1 } from './sc-icon2.js';

const scEmptyCss = ":host{display:block}.empty{display:flex;flex-direction:column;align-items:center;padding:var(--sc-spacing-large);text-align:center;gap:var(--sc-spacing-x-small);color:var(--sc-empty-color, var(--sc-color-gray-500))}.empty sc-icon{font-size:var(--sc-font-size-xx-large);color:var(--sc-empty-icon-color, var(--sc-color-gray-700))}";

const ScEmpty = /*@__PURE__*/ proxyCustomElement(class ScEmpty extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.icon = undefined;
  }
  render() {
    return (h("div", { part: "base", class: "empty" }, !!this.icon && h("sc-icon", { exportparts: "base:icon", name: this.icon }), h("slot", null)));
  }
  static get style() { return scEmptyCss; }
}, [1, "sc-empty", {
    "icon": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-empty", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-empty":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScEmpty);
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScEmpty as S, defineCustomElement as d };

//# sourceMappingURL=sc-empty2.js.map