import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { g as getAdditionalErrorMessages } from './getters4.js';
import { s as state } from './store2.js';
import { d as defineCustomElement$2 } from './sc-alert2.js';
import { d as defineCustomElement$1 } from './sc-icon2.js';

const ScFormErrorProvider = /*@__PURE__*/ proxyCustomElement(class ScFormErrorProvider extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.scUpdateError = createEvent(this, "scUpdateError", 7);
    this.error = undefined;
  }
  /** Trigger the error event when an error happens  */
  handleErrorUpdate(val) {
    this.scUpdateError.emit(val);
  }
  render() {
    return !!(state === null || state === void 0 ? void 0 : state.message) ? (h("sc-alert", { exportparts: "base, icon, text, title, message, close", type: "danger", scrollOnOpen: true, open: !!(state === null || state === void 0 ? void 0 : state.message), closable: !!(state === null || state === void 0 ? void 0 : state.dismissible) }, (state === null || state === void 0 ? void 0 : state.message) && h("span", { slot: "title", innerHTML: state.message }), (getAdditionalErrorMessages() || []).map((message, index) => (h("div", { innerHTML: message, key: index }))))) : null;
  }
  static get watchers() { return {
    "error": ["handleErrorUpdate"]
  }; }
}, [1, "sc-error", {
    "error": [16]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-error", "sc-alert", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-error":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScFormErrorProvider);
      }
      break;
    case "sc-alert":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScFormErrorProvider as S, defineCustomElement as d };

//# sourceMappingURL=sc-error2.js.map