import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$2 } from './sc-icon2.js';

const scFeatureDemoBannerCss = ".sc-banner{background-color:var(--sc-color-brand-primary);color:white;display:flex;align-items:center;justify-content:center}.sc-banner>p{font-size:14px;line-height:1;margin:var(--sc-spacing-small)}.sc-banner>p a{color:inherit;font-weight:600;margin-left:10px;display:inline-flex;align-items:center;gap:8px;text-decoration:none;border-bottom:1px solid;padding-bottom:2px}";

const ScFeatureDemoBanner$1 = /*@__PURE__*/ proxyCustomElement(class ScFeatureDemoBanner extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.url = 'https://app.surecart.com/billing';
    this.buttonText = __('Upgrade Your Plan', 'surecart');
  }
  render() {
    return (h("div", { class: { 'sc-banner': true } }, h("p", null, h("slot", null, __('This is a feature demo. In order to use it, you must upgrade your plan.', 'surecart')), h("a", { href: this.url, target: "_blank" }, h("slot", { name: "link" }, this.buttonText, " ", h("sc-icon", { name: "arrow-right" }))))));
  }
  static get style() { return scFeatureDemoBannerCss; }
}, [1, "sc-feature-demo-banner", {
    "url": [1],
    "buttonText": [1, "button-text"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-feature-demo-banner", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-feature-demo-banner":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScFeatureDemoBanner$1);
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScFeatureDemoBanner = ScFeatureDemoBanner$1;
const defineCustomElement = defineCustomElement$1;

export { ScFeatureDemoBanner, defineCustomElement };

//# sourceMappingURL=sc-feature-demo-banner.js.map