import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state, o as onChange } from './mutations2.js';
import { s as shippingAddressRequired } from './getters2.js';
import { d as defineCustomElement$t } from './sc-address2.js';
import { d as defineCustomElement$s } from './sc-block-ui2.js';
import { d as defineCustomElement$r } from './sc-button2.js';
import { d as defineCustomElement$q } from './sc-choice2.js';
import { d as defineCustomElement$p } from './sc-compact-address2.js';
import { d as defineCustomElement$o } from './sc-divider2.js';
import { d as defineCustomElement$n } from './dropdown.js';
import { d as defineCustomElement$m } from './sc-form-control2.js';
import { d as defineCustomElement$l } from './sc-format-number2.js';
import { d as defineCustomElement$k } from './sc-icon2.js';
import { d as defineCustomElement$j } from './sc-input2.js';
import { d as defineCustomElement$i } from './sc-line-item2.js';
import { d as defineCustomElement$h } from './sc-line-item-shipping2.js';
import { d as defineCustomElement$g } from './sc-line-item-tax2.js';
import { d as defineCustomElement$f } from './sc-menu2.js';
import { d as defineCustomElement$e } from './sc-menu-item2.js';
import { d as defineCustomElement$d } from './sc-menu-label2.js';
import { d as defineCustomElement$c } from './sc-order-bump2.js';
import { d as defineCustomElement$b } from './sc-order-bumps2.js';
import { d as defineCustomElement$a } from './sc-order-shipping-address2.js';
import { d as defineCustomElement$9 } from './sc-order-tax-id-input2.js';
import { d as defineCustomElement$8 } from './sc-radio2.js';
import { d as defineCustomElement$7 } from './sc-radio-group2.js';
import { d as defineCustomElement$6 } from './sc-select2.js';
import { d as defineCustomElement$5 } from './sc-shipping-choices2.js';
import { d as defineCustomElement$4 } from './sc-skeleton2.js';
import { d as defineCustomElement$3 } from './sc-spinner2.js';
import { d as defineCustomElement$2 } from './sc-tax-id-input2.js';
import { d as defineCustomElement$1 } from './sc-visually-hidden2.js';

const ScFormComponentsValidator = /*@__PURE__*/ proxyCustomElement(class ScFormComponentsValidator extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.disabled = undefined;
    this.taxProtocol = undefined;
    this.hasAddress = undefined;
    this.hasTaxIDField = undefined;
    this.hasBumpsField = undefined;
    this.hasTaxLine = undefined;
    this.hasBumpLine = undefined;
    this.hasShippingChoices = undefined;
    this.hasShippingAmount = undefined;
  }
  handleOrderChange() {
    var _a, _b, _c, _d, _e, _f, _g;
    // bail if we don't have address invalid error or disabled.
    if (this.disabled)
      return;
    // make sure to add the address field if it's not there.
    if (shippingAddressRequired()) {
      this.addAddressField();
    }
    // add order bumps.
    if ((_c = (_b = (_a = state.checkout) === null || _a === void 0 ? void 0 : _a.recommended_bumps) === null || _b === void 0 ? void 0 : _b.data) === null || _c === void 0 ? void 0 : _c.length) {
      this.addBumps();
    }
    if (!!((_d = state.checkout) === null || _d === void 0 ? void 0 : _d.tax_amount)) {
      this.addTaxLine();
    }
    // add shipping choices.
    if (((_e = state.checkout) === null || _e === void 0 ? void 0 : _e.shipping_enabled) && ((_f = state.checkout) === null || _f === void 0 ? void 0 : _f.selected_shipping_choice_required)) {
      this.addShippingChoices();
    }
    if (!!((_g = state.checkout) === null || _g === void 0 ? void 0 : _g.shipping_amount)) {
      this.addShippingAmount();
    }
  }
  handleHasAddressChange() {
    if (!this.hasAddress)
      return;
    this.handleShippingAddressRequired();
  }
  componentWillLoad() {
    var _a, _b;
    this.hasAddress = !!this.el.querySelector('sc-order-shipping-address');
    this.hasTaxIDField = !!this.el.querySelector('sc-order-tax-id-input');
    this.hasBumpsField = !!this.el.querySelector('sc-order-bumps');
    this.hasTaxLine = !!this.el.querySelector('sc-line-item-tax');
    this.hasShippingChoices = !!this.el.querySelector('sc-shipping-choices');
    this.hasShippingAmount = !!this.el.querySelector('sc-line-item-shipping');
    // automatically add address field if tax is enabled.
    if ((_a = this.taxProtocol) === null || _a === void 0 ? void 0 : _a.tax_enabled) {
      this.addAddressField();
      // if eu vat is required, add the tax id field.
      if ((_b = this.taxProtocol) === null || _b === void 0 ? void 0 : _b.eu_vat_required) {
        this.addTaxIDField();
      }
    }
    this.removeCheckoutListener = onChange('checkout', () => this.handleOrderChange());
  }
  disconnectedCallback() {
    this.removeCheckoutListener();
  }
  handleShippingAddressRequired() {
    var _a;
    if (!((_a = state.checkout) === null || _a === void 0 ? void 0 : _a.shipping_address_required))
      return;
    // get the address
    const address = this.el.querySelector('sc-order-shipping-address');
    if (!address)
      return;
    // require the address.
    address.required = true;
    // if we have a customer name field, require that.
    const customerName = this.el.querySelector('sc-customer-name');
    if (!!customerName) {
      customerName.required = true;
      return;
    }
    // require the name and show the name input.
    address.requireName = true;
    address.showName = true;
  }
  addAddressField() {
    if (this.hasAddress) {
      return;
    }
    const payment = this.el.querySelector('sc-payment');
    const address = document.createElement('sc-order-shipping-address');
    address.label = __('Address', 'surecart');
    payment.parentNode.insertBefore(address, payment);
    this.hasAddress = true;
  }
  addTaxIDField() {
    if (this.hasTaxIDField)
      return;
    const payment = this.el.querySelector('sc-payment');
    const taxInput = document.createElement('sc-order-tax-id-input');
    payment.parentNode.insertBefore(taxInput, payment);
    this.hasTaxIDField = true;
  }
  addBumps() {
    if (this.hasBumpsField)
      return;
    const payment = this.el.querySelector('sc-payment');
    const bumps = document.createElement('sc-order-bumps');
    payment.parentNode.insertBefore(bumps, payment.nextSibling);
    this.hasBumpsField = true;
  }
  addTaxLine() {
    var _a;
    if (this.hasTaxLine)
      return;
    const total = this.el.querySelector('sc-line-item-total[total=total]');
    const tax = document.createElement('sc-line-item-tax');
    if (((_a = total === null || total === void 0 ? void 0 : total.previousElementSibling) === null || _a === void 0 ? void 0 : _a.tagName) === 'SC-DIVIDER') {
      total.parentNode.insertBefore(tax, total.previousElementSibling);
    }
    else {
      total.parentNode.insertBefore(tax, total);
    }
    this.hasTaxLine = true;
  }
  addShippingChoices() {
    if (this.hasShippingChoices)
      return;
    const payment = this.el.querySelector('sc-payment');
    const shippingChoices = document.createElement('sc-shipping-choices');
    payment.parentNode.insertBefore(shippingChoices, payment);
    this.hasShippingChoices = true;
  }
  addShippingAmount() {
    var _a;
    if (this.hasShippingAmount)
      return;
    let insertBeforeElement = this.el.querySelector('sc-line-item-tax');
    const total = this.el.querySelector('sc-line-item-total[total=total]');
    if (!insertBeforeElement) {
      insertBeforeElement = ((_a = total === null || total === void 0 ? void 0 : total.previousElementSibling) === null || _a === void 0 ? void 0 : _a.tagName) === 'SC-DIVIDER' ? total.previousElementSibling : total;
    }
    const shippingAmount = document.createElement('sc-line-item-shipping');
    insertBeforeElement.parentNode.insertBefore(shippingAmount, insertBeforeElement);
    this.hasShippingAmount = true;
  }
  render() {
    return h("slot", null);
  }
  get el() { return this; }
  static get watchers() { return {
    "hasAddress": ["handleHasAddressChange"]
  }; }
}, [1, "sc-form-components-validator", {
    "disabled": [4],
    "taxProtocol": [16],
    "hasAddress": [32],
    "hasTaxIDField": [32],
    "hasBumpsField": [32],
    "hasTaxLine": [32],
    "hasBumpLine": [32],
    "hasShippingChoices": [32],
    "hasShippingAmount": [32]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-form-components-validator", "sc-address", "sc-block-ui", "sc-button", "sc-choice", "sc-compact-address", "sc-divider", "sc-dropdown", "sc-form-control", "sc-format-number", "sc-icon", "sc-input", "sc-line-item", "sc-line-item-shipping", "sc-line-item-tax", "sc-menu", "sc-menu-item", "sc-menu-label", "sc-order-bump", "sc-order-bumps", "sc-order-shipping-address", "sc-order-tax-id-input", "sc-radio", "sc-radio-group", "sc-select", "sc-shipping-choices", "sc-skeleton", "sc-spinner", "sc-tax-id-input", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-form-components-validator":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScFormComponentsValidator);
      }
      break;
    case "sc-address":
      if (!customElements.get(tagName)) {
        defineCustomElement$t();
      }
      break;
    case "sc-block-ui":
      if (!customElements.get(tagName)) {
        defineCustomElement$s();
      }
      break;
    case "sc-button":
      if (!customElements.get(tagName)) {
        defineCustomElement$r();
      }
      break;
    case "sc-choice":
      if (!customElements.get(tagName)) {
        defineCustomElement$q();
      }
      break;
    case "sc-compact-address":
      if (!customElements.get(tagName)) {
        defineCustomElement$p();
      }
      break;
    case "sc-divider":
      if (!customElements.get(tagName)) {
        defineCustomElement$o();
      }
      break;
    case "sc-dropdown":
      if (!customElements.get(tagName)) {
        defineCustomElement$n();
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$m();
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$l();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$k();
      }
      break;
    case "sc-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$j();
      }
      break;
    case "sc-line-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$i();
      }
      break;
    case "sc-line-item-shipping":
      if (!customElements.get(tagName)) {
        defineCustomElement$h();
      }
      break;
    case "sc-line-item-tax":
      if (!customElements.get(tagName)) {
        defineCustomElement$g();
      }
      break;
    case "sc-menu":
      if (!customElements.get(tagName)) {
        defineCustomElement$f();
      }
      break;
    case "sc-menu-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$e();
      }
      break;
    case "sc-menu-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$d();
      }
      break;
    case "sc-order-bump":
      if (!customElements.get(tagName)) {
        defineCustomElement$c();
      }
      break;
    case "sc-order-bumps":
      if (!customElements.get(tagName)) {
        defineCustomElement$b();
      }
      break;
    case "sc-order-shipping-address":
      if (!customElements.get(tagName)) {
        defineCustomElement$a();
      }
      break;
    case "sc-order-tax-id-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$9();
      }
      break;
    case "sc-radio":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "sc-radio-group":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "sc-select":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-shipping-choices":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-skeleton":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-spinner":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-tax-id-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScFormComponentsValidator as S, defineCustomElement as d };

//# sourceMappingURL=sc-form-components-validator2.js.map