import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { d as defineCustomElement$3 } from './sc-alert2.js';
import { d as defineCustomElement$2 } from './sc-checkout-form-errors2.js';
import { d as defineCustomElement$1 } from './sc-icon2.js';

const ScFormErrorProvider = /*@__PURE__*/ proxyCustomElement(class ScFormErrorProvider extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  componentWillLoad() {
    this.maybeAddErrorsComponent();
  }
  maybeAddErrorsComponent() {
    var _a, _b;
    if (!!this.el.querySelector('sc-checkout-form-errors'))
      return;
    const errorsComponent = document.createElement('sc-checkout-form-errors');
    (_b = (_a = this.el.querySelector('sc-form')) === null || _a === void 0 ? void 0 : _a.prepend) === null || _b === void 0 ? void 0 : _b.call(_a, errorsComponent);
  }
  render() {
    return h("slot", null);
  }
  get el() { return this; }
}, [1, "sc-form-error-provider"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-form-error-provider", "sc-alert", "sc-checkout-form-errors", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-form-error-provider":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScFormErrorProvider);
      }
      break;
    case "sc-alert":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-checkout-form-errors":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScFormErrorProvider as S, defineCustomElement as d };

//# sourceMappingURL=sc-form-error-provider2.js.map