import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$1 } from './sc-tag2.js';

const scFulfillmentShippingStatusBadgeCss = ":host{display:inline-block}";

const status = {
  unshipped: __('Not Shipped', 'surecart'),
  shipped: __('Shipped', 'surecart'),
  delivered: __('Delivered', 'surecart'),
};
const type = {
  unshipped: 'default',
  shipped: 'info',
  delivered: 'success',
};
const ScOrderStatusBadge = /*@__PURE__*/ proxyCustomElement(class ScOrderStatusBadge extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.status = undefined;
    this.size = 'medium';
    this.pill = false;
    this.clearable = false;
  }
  render() {
    // don't render if not shippable.
    if (this.status === 'unshippable') {
      return h(Host, { style: { display: 'none' } });
    }
    return (h("sc-tag", { type: type === null || type === void 0 ? void 0 : type[this === null || this === void 0 ? void 0 : this.status], pill: this.pill }, (status === null || status === void 0 ? void 0 : status[this.status]) || this.status));
  }
  static get style() { return scFulfillmentShippingStatusBadgeCss; }
}, [1, "sc-fulfillment-shipping-status-badge", {
    "status": [1],
    "size": [513],
    "pill": [516],
    "clearable": [4]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-fulfillment-shipping-status-badge", "sc-tag"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-fulfillment-shipping-status-badge":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderStatusBadge);
      }
      break;
    case "sc-tag":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScOrderStatusBadge as S, defineCustomElement as d };

//# sourceMappingURL=sc-fulfillment-shipping-status-badge2.js.map