import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state } from './mutations2.js';
import { d as defineCustomElement$3 } from './sc-format-number2.js';
import { d as defineCustomElement$2 } from './sc-line-item2.js';

const scLineItemBumpCss = ":host{display:block}";

const ScLineItemBump$1 = /*@__PURE__*/ proxyCustomElement(class ScLineItemBump extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.label = undefined;
    this.loading = undefined;
  }
  render() {
    var _a, _b, _c;
    if (!((_a = state === null || state === void 0 ? void 0 : state.checkout) === null || _a === void 0 ? void 0 : _a.bump_amount)) {
      return h(Host, { style: { display: 'none' } });
    }
    return (h("sc-line-item", null, h("span", { slot: "description" }, this.label || __('Bundle Discount', 'surecart')), h("span", { slot: "price" }, h("sc-format-number", { type: "currency", currency: ((_b = state === null || state === void 0 ? void 0 : state.checkout) === null || _b === void 0 ? void 0 : _b.currency) || 'usd', value: (_c = state === null || state === void 0 ? void 0 : state.checkout) === null || _c === void 0 ? void 0 : _c.bump_amount }))));
  }
  static get style() { return scLineItemBumpCss; }
}, [1, "sc-line-item-bump", {
    "label": [1],
    "loading": [4]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-line-item-bump", "sc-format-number", "sc-line-item"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-line-item-bump":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScLineItemBump$1);
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-line-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScLineItemBump = ScLineItemBump$1;
const defineCustomElement = defineCustomElement$1;

export { ScLineItemBump, defineCustomElement };

//# sourceMappingURL=sc-line-item-bump.js.map