import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state } from './store3.js';
import { s as state$1 } from './mutations2.js';
import { d as defineCustomElement$3 } from './sc-format-number2.js';
import { d as defineCustomElement$2 } from './sc-line-item2.js';
import { d as defineCustomElement$1 } from './sc-skeleton2.js';

const scLineItemShippingCss = ":host{display:block}";

const ScLineItemShipping = /*@__PURE__*/ proxyCustomElement(class ScLineItemShipping extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.label = undefined;
  }
  render() {
    const { checkout } = state$1;
    // don't show if no shipping amount if no choice selected
    if (!(checkout === null || checkout === void 0 ? void 0 : checkout.selected_shipping_choice)) {
      return h(Host, { style: { display: 'none' } });
    }
    if (state.formState.value === 'loading') {
      return (h("sc-line-item", null, h("sc-skeleton", { slot: "title", style: { width: '120px', display: 'inline-block' } }), h("sc-skeleton", { slot: "price", style: { 'width': '70px', 'display': 'inline-block', '--border-radius': '6px' } })));
    }
    return (h("sc-line-item", null, h("span", { slot: "description" }, this.label || __('Shipping', 'surecart')), h("span", { slot: "price" }, (checkout === null || checkout === void 0 ? void 0 : checkout.shipping_amount) ? (h("sc-format-number", { type: "currency", currency: checkout === null || checkout === void 0 ? void 0 : checkout.currency, value: checkout === null || checkout === void 0 ? void 0 : checkout.shipping_amount })) : (__('Free', 'surecart')))));
  }
  static get style() { return scLineItemShippingCss; }
}, [1, "sc-line-item-shipping", {
    "label": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-line-item-shipping", "sc-format-number", "sc-line-item", "sc-skeleton"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-line-item-shipping":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScLineItemShipping);
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-line-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-skeleton":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScLineItemShipping as S, defineCustomElement as d };

//# sourceMappingURL=sc-line-item-shipping2.js.map