import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const scMenuLabelCss = ":host{display:block}.menu-label{font-family:var(--sc-font-sans);font-size:var(--sc-font-size-x-small);font-weight:var(--sc-font-weight-semibold);line-height:var(--sc-line-height-normal);letter-spacing:var(--sc-letter-spacing-normal);color:var(--sc-color-gray-500);padding:var(--sc-spacing-small) var(--sc-spacing-large);user-select:none;text-transform:uppercase}";

const ScMenuLabel = /*@__PURE__*/ proxyCustomElement(class ScMenuLabel extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h("div", { part: "base", class: "menu-label" }, h("slot", null)));
  }
  static get style() { return scMenuLabelCss; }
}, [1, "sc-menu-label"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-menu-label"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-menu-label":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScMenuLabel);
      }
      break;
  } });
}

export { ScMenuLabel as S, defineCustomElement as d };

//# sourceMappingURL=sc-menu-label2.js.map