import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state } from './mutations2.js';
import { d as defineCustomElement$6 } from './sc-choice2.js';
import { d as defineCustomElement$5 } from './sc-divider2.js';
import { d as defineCustomElement$4 } from './sc-form-control2.js';
import { d as defineCustomElement$3 } from './sc-format-number2.js';
import { d as defineCustomElement$2 } from './sc-order-bump2.js';
import { d as defineCustomElement$1 } from './sc-visually-hidden2.js';

const scOrderBumpsCss = ":host{display:block}.bumps__list{display:grid;gap:10px}";

const ScOrderBumps = /*@__PURE__*/ proxyCustomElement(class ScOrderBumps extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.label = undefined;
    this.showControl = undefined;
    this.help = undefined;
  }
  render() {
    var _a, _b;
    const bumps = (((_b = (_a = state === null || state === void 0 ? void 0 : state.checkout) === null || _a === void 0 ? void 0 : _a.recommended_bumps) === null || _b === void 0 ? void 0 : _b.data) || []).filter(bump => { var _a, _b, _c, _d; return ((_d = (_c = (_b = (_a = bump === null || bump === void 0 ? void 0 : bump.price) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.variants) === null || _c === void 0 ? void 0 : _c.pagination) === null || _d === void 0 ? void 0 : _d.count) === 0; }); // exclude variants for now.;
    if (!(bumps === null || bumps === void 0 ? void 0 : bumps.length)) {
      return null;
    }
    return (h("sc-form-control", { label: this.label || __('Recommended', 'surecart'), help: this.help }, h("div", { class: "bumps__list", "aria-label": __('Order bump summary', 'surecart') }, bumps.map(bump => (h("sc-order-bump", { key: bump === null || bump === void 0 ? void 0 : bump.id, showControl: this.showControl, bump: bump }))))));
  }
  static get style() { return scOrderBumpsCss; }
}, [1, "sc-order-bumps", {
    "label": [1],
    "showControl": [4, "show-control"],
    "help": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-order-bumps", "sc-choice", "sc-divider", "sc-form-control", "sc-format-number", "sc-order-bump", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-order-bumps":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderBumps);
      }
      break;
    case "sc-choice":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-divider":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-order-bump":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScOrderBumps as S, defineCustomElement as d };

//# sourceMappingURL=sc-order-bumps2.js.map