import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$2 } from './sc-tag2.js';

const scOrderFulfillmentBadgeCss = ":host{display:inline-block}";

const status = {
  unfulfilled: __('Unfulfilled', 'surecart'),
  fulfilled: __('Fulfilled', 'surecart'),
  on_hold: __('On Hold', 'surecart'),
  scheduled: __('Scheduled', 'surecart'),
  partially_fulfilled: __('Partially Fulfilled', 'surecart'),
};
const type = {
  unfulfilled: 'warning',
  fulfilled: 'success',
  on_hold: 'warning',
  scheduled: 'default',
  partially_fulfilled: 'warning',
};
const ScOrderFulFillmentBadge = /*@__PURE__*/ proxyCustomElement(class ScOrderFulFillmentBadge extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.status = undefined;
    this.size = 'medium';
    this.pill = false;
    this.clearable = false;
  }
  render() {
    return (h("sc-tag", { type: type === null || type === void 0 ? void 0 : type[this === null || this === void 0 ? void 0 : this.status], pill: this.pill }, (status === null || status === void 0 ? void 0 : status[this.status]) || this.status));
  }
  static get style() { return scOrderFulfillmentBadgeCss; }
}, [1, "sc-order-fulfillment-badge", {
    "status": [1],
    "size": [513],
    "pill": [516],
    "clearable": [4]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-order-fulfillment-badge", "sc-tag"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-order-fulfillment-badge":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderFulFillmentBadge);
      }
      break;
    case "sc-tag":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScOrderFulfillmentBadge = ScOrderFulFillmentBadge;
const defineCustomElement = defineCustomElement$1;

export { ScOrderFulfillmentBadge, defineCustomElement };

//# sourceMappingURL=sc-order-fulfillment-badge.js.map