import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { o as openWormhole } from './consumer.js';
import { d as defineCustomElement$5 } from './sc-form-control2.js';
import { d as defineCustomElement$4 } from './sc-input2.js';
import { d as defineCustomElement$3 } from './sc-password2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';

const scOrderPasswordCss = ":host{display:block}.password{display:grid;gap:var(--sc-form-row-spacing, 0.75em)}.password__hint{padding-top:0.36rem;color:red}";

const ScOrderPassword$1 = /*@__PURE__*/ proxyCustomElement(class ScOrderPassword extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.loggedIn = undefined;
    this.size = 'medium';
    this.value = '';
    this.pill = false;
    this.label = undefined;
    this.showLabel = true;
    this.help = '';
    this.placeholder = undefined;
    this.disabled = false;
    this.readonly = false;
    this.required = false;
    this.autofocus = undefined;
    this.emailExists = undefined;
    this.confirmation = false;
    this.confirmationLabel = undefined;
    this.confirmationPlaceholder = undefined;
    this.confirmationHelp = undefined;
    this.enableValidation = true;
  }
  async reportValidity() {
    var _a, _b;
    return (_b = (_a = this.input) === null || _a === void 0 ? void 0 : _a.reportValidity) === null || _b === void 0 ? void 0 : _b.call(_a);
  }
  render() {
    if (this.loggedIn) {
      return h(Host, { style: { display: 'none' } });
    }
    return (h("sc-password", { label: this.label, "aria-label": this.label, help: this.help, autofocus: this.autofocus, placeholder: this.placeholder, showLabel: this.showLabel, size: this.size ? this.size : 'medium', name: "password", ref: el => (this.input = el), value: this.value, required: this.required, disabled: this.disabled, enableValidation: this.enableValidation, confirmationHelp: this.confirmationHelp, confirmationLabel: this.confirmationLabel, confirmationPlaceholder: this.confirmationPlaceholder, confirmation: this.confirmation }));
  }
  static get style() { return scOrderPasswordCss; }
}, [1, "sc-order-password", {
    "loggedIn": [4, "logged-in"],
    "size": [513],
    "value": [1025],
    "pill": [516],
    "label": [1],
    "showLabel": [4, "show-label"],
    "help": [1],
    "placeholder": [1],
    "disabled": [516],
    "readonly": [516],
    "required": [516],
    "autofocus": [4],
    "emailExists": [4, "email-exists"],
    "confirmation": [516],
    "confirmationLabel": [1, "confirmation-label"],
    "confirmationPlaceholder": [1, "confirmation-placeholder"],
    "confirmationHelp": [1, "confirmation-help"],
    "enableValidation": [516, "enable-validation"],
    "reportValidity": [64]
  }]);
openWormhole(ScOrderPassword$1, ['loggedIn', 'emailExists'], false);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-order-password", "sc-form-control", "sc-input", "sc-password", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-order-password":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderPassword$1);
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-password":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScOrderPassword = ScOrderPassword$1;
const defineCustomElement = defineCustomElement$1;

export { ScOrderPassword, defineCustomElement };

//# sourceMappingURL=sc-order-password.js.map