import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$2 } from './sc-tag2.js';

const scOrderReturnBadgeCss = ":host{display:inline-block}";

const status = {
  open: __('Return in progress', 'surecart'),
  completed: __('Returned', 'surecart'),
};
const type = {
  open: 'warning',
  completed: 'success',
};
const ScOrderReturnBadge$1 = /*@__PURE__*/ proxyCustomElement(class ScOrderReturnBadge extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.status = undefined;
    this.size = 'medium';
    this.pill = false;
    this.clearable = false;
  }
  render() {
    return (h("sc-tag", { type: type === null || type === void 0 ? void 0 : type[this === null || this === void 0 ? void 0 : this.status], pill: this.pill }, (status === null || status === void 0 ? void 0 : status[this.status]) || this.status));
  }
  static get style() { return scOrderReturnBadgeCss; }
}, [1, "sc-order-return-badge", {
    "status": [1],
    "size": [513],
    "pill": [516],
    "clearable": [4]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-order-return-badge", "sc-tag"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-order-return-badge":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderReturnBadge$1);
      }
      break;
    case "sc-tag":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScOrderReturnBadge = ScOrderReturnBadge$1;
const defineCustomElement = defineCustomElement$1;

export { ScOrderReturnBadge, defineCustomElement };

//# sourceMappingURL=sc-order-return-badge.js.map