import { proxyCustomElement, HTMLElement, h, Fragment } from '@stencil/core/internal/client';
import { c as checkoutIsLocked } from './getters2.js';
import { a as availableProcessors } from './getters5.js';
import { s as state$1 } from './watchers5.js';
import { s as state } from './mutations2.js';
import { _ as __ } from './default-i18n.js';
import { o as openWormhole } from './consumer.js';
import { f as formBusy } from './getters3.js';
import { d as defineCustomElement$a } from './sc-button2.js';
import { d as defineCustomElement$9 } from './sc-format-number2.js';
import { d as defineCustomElement$8 } from './sc-icon2.js';
import { d as defineCustomElement$7 } from './paypal-buttons.js';
import { d as defineCustomElement$6 } from './sc-secure-notice2.js';
import { d as defineCustomElement$5 } from './sc-skeleton2.js';
import { d as defineCustomElement$4 } from './sc-spinner2.js';
import { d as defineCustomElement$3 } from './sc-total2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';

const getProcessorData = (processors = [], type, mode) => {
  var _a;
  return ((_a = (processors || []).find(processor => (processor === null || processor === void 0 ? void 0 : processor.processor_type) === type && (processor === null || processor === void 0 ? void 0 : processor.live_mode) === !!(mode === 'live'))) === null || _a === void 0 ? void 0 : _a.processor_data) || {};
};

const scOrderSubmitCss = "sc-order-submit{display:block;width:auto;display:grid;gap:var(--sc-form-row-spacing)}.sc-secure-notice{display:flex;justify-content:center}";

const ScOrderSubmit$1 = /*@__PURE__*/ proxyCustomElement(class ScOrderSubmit extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.loading = undefined;
    this.paying = undefined;
    this.type = 'primary';
    this.size = 'medium';
    this.full = true;
    this.icon = undefined;
    this.showTotal = undefined;
    this.processors = undefined;
    this.order = undefined;
    this.currencyCode = 'usd';
    this.processor = undefined;
    this.secureNoticeText = undefined;
    this.secureNotice = true;
  }
  cannotShipToLocation() {
    var _a, _b;
    return ((_a = state === null || state === void 0 ? void 0 : state.checkout) === null || _a === void 0 ? void 0 : _a.selected_shipping_choice_required) && !((_b = state.checkout) === null || _b === void 0 ? void 0 : _b.selected_shipping_choice);
  }
  renderPayPalButton(buttons) {
    const { client_id, account_id, merchant_initiated_enabled } = getProcessorData(availableProcessors(), 'paypal', state.mode);
    if (!client_id && !account_id)
      return null;
    return (h("sc-paypal-buttons", { buttons: buttons, busy: formBusy() || checkoutIsLocked(), mode: state.mode, order: state.checkout, merchantInitiated: merchant_initiated_enabled, "currency-code": state.currencyCode, "client-id": client_id, "merchant-id": account_id, label: "checkout", color: "blue" }));
  }
  render() {
    if (this.cannotShipToLocation() || checkoutIsLocked('OUT_OF_STOCK')) {
      return (h("sc-button", { type: this.type, size: this.size, full: this.full, loading: this.loading || this.paying, disabled: true }, !!this.icon && h("sc-icon", { name: this.icon, slot: "prefix", "aria-hidden": "true" }), h("slot", null, __('Purchase', 'surecart')), this.showTotal && (h("span", null, '\u00A0', h("sc-total", null))), h("sc-visually-hidden", null, " ", __('Press enter to purchase', 'surecart'))));
    }
    return (h(Fragment, null, state$1.id === 'paypal' && !(state$1 === null || state$1 === void 0 ? void 0 : state$1.method) && this.renderPayPalButton(['paypal']), state$1.id === 'paypal' && (state$1 === null || state$1 === void 0 ? void 0 : state$1.method) === 'card' && this.renderPayPalButton(['card']), h("sc-button", { hidden: ['paypal', 'paypal-card'].includes(state$1.id), submit: true, type: this.type, size: this.size, full: this.full, loading: this.loading || this.paying, disabled: this.loading || this.paying || formBusy() || checkoutIsLocked() || this.cannotShipToLocation() }, !!this.icon && h("sc-icon", { name: this.icon, slot: "prefix", "aria-hidden": "true" }), h("slot", null, __('Purchase', 'surecart')), this.showTotal && (h("span", null, '\u00A0', h("sc-total", null))), h("sc-visually-hidden", null, " ", __('Press enter to purchase', 'surecart'))), this.secureNotice && location.protocol === 'https:' && (h("div", { class: "sc-secure-notice" }, h("sc-secure-notice", null, this.secureNoticeText || __('This is a secure, encrypted payment.', 'surecart'))))));
  }
  static get style() { return scOrderSubmitCss; }
}, [4, "sc-order-submit", {
    "loading": [4],
    "paying": [4],
    "type": [513],
    "size": [513],
    "full": [4],
    "icon": [1],
    "showTotal": [4, "show-total"],
    "processors": [16],
    "order": [16],
    "currencyCode": [1, "currency-code"],
    "processor": [1],
    "secureNoticeText": [1, "secure-notice-text"],
    "secureNotice": [4, "secure-notice"]
  }]);
openWormhole(ScOrderSubmit$1, ['loading', 'paying', 'processors', 'processor', 'currencyCode', 'order'], false);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-order-submit", "sc-button", "sc-format-number", "sc-icon", "sc-paypal-buttons", "sc-secure-notice", "sc-skeleton", "sc-spinner", "sc-total", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-order-submit":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScOrderSubmit$1);
      }
      break;
    case "sc-button":
      if (!customElements.get(tagName)) {
        defineCustomElement$a();
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$9();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "sc-paypal-buttons":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "sc-secure-notice":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-skeleton":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-spinner":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-total":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScOrderSubmit = ScOrderSubmit$1;
const defineCustomElement = defineCustomElement$1;

export { ScOrderSubmit, defineCustomElement };

//# sourceMappingURL=sc-order-submit.js.map