import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { s as sprintf, _ as __ } from './default-i18n.js';
import { i as isInRange } from './util.js';
import { s as state, c as getInRangeAmounts, u as updateDonationState } from './watchers3.js';
import { d as defineCustomElement$3 } from './sc-choice-container2.js';
import { d as defineCustomElement$2 } from './sc-format-number2.js';

const scProductDonationAmountChoiceCss = "";

const ScProductDonationAmountChoice$1 = /*@__PURE__*/ proxyCustomElement(class ScProductDonationAmountChoice extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.productId = undefined;
    this.value = undefined;
    this.label = undefined;
  }
  state() {
    return state[this.productId];
  }
  render() {
    var _a;
    const amounts = getInRangeAmounts(this.productId);
    const order = amounts.indexOf(this.value);
    if (!isInRange(this.value, this.state().selectedPrice) || order < 0)
      return h(Host, { style: { display: 'none' } });
    return (h("sc-choice-container", { "show-control": "false", checked: this.state().ad_hoc_amount === this.value, onScChange: () => updateDonationState(this.productId, { ad_hoc_amount: this.value, custom_amount: null }), "aria-label": sprintf(__('%s of %s', 'surecart'), order + 1, amounts.length), role: "button" }, this.label ? (this.label) : (h("sc-format-number", { type: "currency", currency: (_a = this.state().selectedPrice) === null || _a === void 0 ? void 0 : _a.currency, value: this.value, "minimum-fraction-digits": "0" }))));
  }
  get el() { return this; }
  static get style() { return scProductDonationAmountChoiceCss; }
}, [0, "sc-product-donation-amount-choice", {
    "productId": [513, "product-id"],
    "value": [2],
    "label": [1]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-donation-amount-choice", "sc-choice-container", "sc-format-number"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-donation-amount-choice":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductDonationAmountChoice$1);
      }
      break;
    case "sc-choice-container":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProductDonationAmountChoice = ScProductDonationAmountChoice$1;
const defineCustomElement = defineCustomElement$1;

export { ScProductDonationAmountChoice, defineCustomElement };

//# sourceMappingURL=sc-product-donation-amount-choice.js.map