import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state } from './watchers3.js';
import { d as defineCustomElement$8 } from './sc-choice-container2.js';
import { d as defineCustomElement$7 } from './dropdown.js';
import { d as defineCustomElement$6 } from './sc-format-number2.js';
import { d as defineCustomElement$5 } from './sc-icon2.js';
import { d as defineCustomElement$4 } from './sc-menu2.js';
import { d as defineCustomElement$3 } from './sc-menu-item2.js';
import { d as defineCustomElement$2 } from './sc-recurring-price-choice-container2.js';

const scProductDonationChoicesCss = ":host{display:block}.sc-product-donation-choices{display:grid;gap:2em;position:relative;--columns:4}.sc-product-donation-choices__form{display:grid;gap:var(--sc-spacing-small)}.sc-donation-recurring-choices{display:grid;gap:var(--sc-spacing-small);position:relative;--columns:2}";

const ScProductDonationChoice = /*@__PURE__*/ proxyCustomElement(class ScProductDonationChoice extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.productId = undefined;
    this.label = undefined;
    this.recurring = undefined;
  }
  state() {
    return state[this.productId];
  }
  updateState(data) {
    state[this.productId] = {
      ...state[this.productId],
      ...data,
    };
  }
  render() {
    var _a, _b, _c, _d;
    const prices = (((_c = (_b = (_a = this.state()) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.prices) === null || _c === void 0 ? void 0 : _c.data) || [])
      .filter(price => (this.recurring ? (price === null || price === void 0 ? void 0 : price.recurring_interval) && (price === null || price === void 0 ? void 0 : price.ad_hoc) : !(price === null || price === void 0 ? void 0 : price.recurring_interval) && (price === null || price === void 0 ? void 0 : price.ad_hoc)))
      .filter(price => !(price === null || price === void 0 ? void 0 : price.archived));
    // no prices, or less than 2 prices, we have no choices.
    if (!(prices === null || prices === void 0 ? void 0 : prices.length)) {
      return h(Host, { style: { display: 'none' } });
    }
    // return price choice container.
    return (h("sc-recurring-price-choice-container", { prices: prices.sort((a, b) => (a === null || a === void 0 ? void 0 : a.position) - (b === null || b === void 0 ? void 0 : b.position)), product: (_d = this.state()) === null || _d === void 0 ? void 0 : _d.product, selectedPrice: this.state().selectedPrice, showDetails: false, showAmount: false, onScChange: e => {
        var _a, _b;
        const selectedPrice = (((_b = (_a = this.state().product) === null || _a === void 0 ? void 0 : _a.prices) === null || _b === void 0 ? void 0 : _b.data) || []).find(({ id }) => id == e.detail);
        this.updateState({ selectedPrice });
      }, "aria-label": this.recurring
        ? __('If you want to make your donation recurring then Press Tab once & select the recurring interval from the dropdown. ', 'surecart')
        : __('If you want to make your donation once then Press Enter. ', 'surecart'), style: { '--sc-recurring-price-choice-white-space': 'wrap', '--sc-recurring-price-choice-text-align': 'left' } }, h("slot", null, this.label)));
  }
  get el() { return this; }
  static get style() { return scProductDonationChoicesCss; }
}, [1, "sc-product-donation-choices", {
    "productId": [513, "product-id"],
    "label": [1],
    "recurring": [4]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-donation-choices", "sc-choice-container", "sc-dropdown", "sc-format-number", "sc-icon", "sc-menu", "sc-menu-item", "sc-recurring-price-choice-container"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-donation-choices":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductDonationChoice);
      }
      break;
    case "sc-choice-container":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "sc-dropdown":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-menu":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-menu-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-recurring-price-choice-container":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProductDonationChoices = ScProductDonationChoice;
const defineCustomElement = defineCustomElement$1;

export { ScProductDonationChoices, defineCustomElement };

//# sourceMappingURL=sc-product-donation-choices.js.map