import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { s as state } from './watchers3.js';
import { d as defineCustomElement$6 } from './sc-choice-container2.js';
import { d as defineCustomElement$5 } from './sc-form-control2.js';
import { d as defineCustomElement$4 } from './sc-input2.js';
import { d as defineCustomElement$3 } from './sc-price-input2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';

const scProductDonationCustomAmountCss = "sc-product-donation-custom-amount sc-price-input sc-button{margin-right:-10px !important}.sc-product-donation-custom-amount sc-button{opacity:0;visibility:hidden;transition:opacity var(--sc-transition-fast) ease-in-out, visibility var(--sc-transition-fast) ease-in-out}.sc-product-donation-custom-amount--has-value sc-button{opacity:1;visibility:visible}";

const ScProductDonationCustomAmount$1 = /*@__PURE__*/ proxyCustomElement(class ScProductDonationCustomAmount extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.productId = undefined;
    this.value = undefined;
  }
  state() {
    return state[this.productId];
  }
  updateState(data) {
    state[this.productId] = {
      ...state[this.productId],
      ...data,
    };
  }
  render() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const checked = !!((_a = this.state()) === null || _a === void 0 ? void 0 : _a.custom_amount);
    return (h(Host, { class: { 'sc-product-donation-custom-amount': true, 'sc-product-donation-custom-amount--has-value': !!this.value } }, h("sc-choice-container", { value: `${(_b = this.state()) === null || _b === void 0 ? void 0 : _b.custom_amount}`, "show-control": "false", checked: checked, onClick: () => this.priceInput.triggerFocus(), onKeyDown: () => {
        this.priceInput.triggerFocus();
      }, role: "button" }, h("sc-visually-hidden", null, __('Enter a custom amount.', 'surecart')), h("sc-price-input", { ref: el => (this.priceInput = el), currencyCode: ((_d = (_c = this.state()) === null || _c === void 0 ? void 0 : _c.selectedPrice) === null || _d === void 0 ? void 0 : _d.currency) || ((_e = window === null || window === void 0 ? void 0 : window.scData) === null || _e === void 0 ? void 0 : _e.currency) || 'usd', showCode: false, showLabel: false, value: `${((_f = this.state()) === null || _f === void 0 ? void 0 : _f.custom_amount) || ''}`, onScChange: e => this.updateState({
        ad_hoc_amount: null,
        custom_amount: e.target.value,
      }), min: (_h = (_g = this.state()) === null || _g === void 0 ? void 0 : _g.selectedPrice) === null || _h === void 0 ? void 0 : _h.ad_hoc_min_amount, max: (_k = (_j = this.state()) === null || _j === void 0 ? void 0 : _j.selectedPrice) === null || _k === void 0 ? void 0 : _k.ad_hoc_max_amount, style: { '--sc-input-border-color-focus': 'var(--sc-input-border-color-hover)', '--sc-focus-ring-color-primary': 'transparent' } }))));
  }
  get el() { return this; }
  static get style() { return scProductDonationCustomAmountCss; }
}, [0, "sc-product-donation-custom-amount", {
    "productId": [1, "product-id"],
    "value": [2]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-donation-custom-amount", "sc-choice-container", "sc-form-control", "sc-input", "sc-price-input", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-donation-custom-amount":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductDonationCustomAmount$1);
      }
      break;
    case "sc-choice-container":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-price-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProductDonationCustomAmount = ScProductDonationCustomAmount$1;
const defineCustomElement = defineCustomElement$1;

export { ScProductDonationCustomAmount, defineCustomElement };

//# sourceMappingURL=sc-product-donation-custom-amount.js.map