import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { s as sizeImage, g as getFeaturedProductMediaAttributes } from './media.js';
import { a as applyFilters } from './index2.js';

const scProductItemImageCss = ":host{border-style:none}.product-img{max-width:100%;aspect-ratio:var(--sc-product-image-aspect-ratio);padding-top:var(--sc-product-image-padding-top, 0);padding-bottom:var(--sc-product-image-padding-bottom, 0);padding-left:var(--sc-product-image-padding-left, 0);padding-right:var(--sc-product-image-padding-right, 0);margin-top:var(--sc-product-image-margin-top, 0);margin-bottom:var(--sc-product-image-margin-bottom, 0);margin-left:var(--sc-product-image-margin-left, 0);margin-right:var(--sc-product-image-margin-right, 0);border:solid var(--sc-product-image-border-width) var(--sc-product-image-border-color);border-radius:var(--sc-product-image-border-radius);overflow:hidden}.product-img>img{width:100%;height:100%;box-sizing:border-box;object-fit:contain;display:block;transition:transform var(--sc-transition-medium) ease}.product-img.is_covered>img{object-fit:cover}.product-img.is_contained>img{object-fit:contain}.product-img_placeholder{width:100%;height:100%;background-color:var(--sc-color-gray-300)}.product-img:hover img{transform:scale(1.05)}";

const ScProductItemImage = /*@__PURE__*/ proxyCustomElement(class ScProductItemImage extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.product = undefined;
    this.sizing = undefined;
  }
  getSrc() {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
    if ((_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.featured_product_media) === null || _b === void 0 ? void 0 : _b.url) {
      return (_d = (_c = this.product) === null || _c === void 0 ? void 0 : _c.featured_product_media) === null || _d === void 0 ? void 0 : _d.url;
    }
    if ((_g = (_f = (_e = this.product) === null || _e === void 0 ? void 0 : _e.featured_product_media) === null || _f === void 0 ? void 0 : _f.media) === null || _g === void 0 ? void 0 : _g.url) {
      return sizeImage((_k = (_j = (_h = this.product) === null || _h === void 0 ? void 0 : _h.featured_product_media) === null || _j === void 0 ? void 0 : _j.media) === null || _k === void 0 ? void 0 : _k.url, applyFilters('surecart/product-list/media/size', 900));
    }
    return `${(_l = window.scData) === null || _l === void 0 ? void 0 : _l.plugin_url}/images/placeholder.jpg`;
  }
  render() {
    const { alt, title } = getFeaturedProductMediaAttributes(this.product);
    return (h(Host, { style: { borderStyle: 'none' } }, h("div", { class: {
        'product-img': true,
        'is_contained': this.sizing === 'contain',
        'is_covered': this.sizing === 'cover',
      } }, !!this.getSrc() ? h("img", { src: this.getSrc(), alt: alt, ...(title ? { title } : {}) }) : h("div", { class: "product-img_placeholder" }))));
  }
  static get style() { return scProductItemImageCss; }
}, [1, "sc-product-item-image", {
    "product": [16],
    "sizing": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-item-image"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-item-image":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductItemImage);
      }
      break;
  } });
}

export { ScProductItemImage as S, defineCustomElement as d };

//# sourceMappingURL=sc-product-item-image2.js.map