import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const scProductItemTitleCss = ".product-item-title{padding-top:var(--sc-product-title-padding-top, 0);padding-bottom:var(--sc-product-title-padding-bottom, 0);margin-top:var(--sc-product-title-margin-top, 0);margin-bottom:var(--sc-product-title-margin-bottom, 0);font-size:var(--sc-product-title-font-size);text-align:var(--sc-product-title-align);font-weight:var(--sc-product-title-font-weight);color:var(--sc-product-title-text-color);line-height:1.2}";

const ScProductItemTitle = /*@__PURE__*/ proxyCustomElement(class ScProductItemTitle extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("div", { class: {
        'product-item-title': true,
      } }, h("slot", null))));
  }
  static get style() { return scProductItemTitleCss; }
}, [1, "sc-product-item-title"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-item-title"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-item-title":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductItemTitle);
      }
      break;
  } });
}

export { ScProductItemTitle as S, defineCustomElement as d };

//# sourceMappingURL=sc-product-item-title2.js.map