import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { d as defineCustomElement$6 } from './sc-format-number2.js';
import { d as defineCustomElement$5 } from './sc-price-range2.js';
import { d as defineCustomElement$4 } from './sc-product-item-image2.js';
import { d as defineCustomElement$3 } from './sc-product-item-price2.js';
import { d as defineCustomElement$2 } from './sc-product-item-title2.js';
import { d as defineCustomElement$1 } from './sc-visually-hidden2.js';

const scProductItemCss = ".product-item{text-decoration:none;padding-top:var(--sc-product-item-padding-top);padding-bottom:var(--sc-product-item-padding-bottom);padding-left:var(--sc-product-item-padding-left);padding-right:var(--sc-product-item-padding-right);margin-top:var(--sc-product-item-margin-top);margin-bottom:var(--sc-product-item-margin-bottom);margin-left:var(--sc-product-item-margin-left);margin-right:var(--sc-product-item-margin-right);border:solid var(--sc-product-item-border-width) var(--sc-product-item-border-color);border-radius:var(--sc-product-item-border-radius);color:var(--sc-product-title-text-color);background-color:var(--sc-product-item-background-color);height:100%;box-sizing:border-box;display:grid}";

const ScProductItem = /*@__PURE__*/ proxyCustomElement(class ScProductItem extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.product = undefined;
    this.layoutConfig = undefined;
  }
  render() {
    var _a;
    return (h("a", { href: (_a = this.product) === null || _a === void 0 ? void 0 : _a.permalink, class: { 'product-item': true } }, this.product &&
      (this.layoutConfig || []).map(layout => {
        var _a, _b, _c, _d;
        const attributes = layout.attributes || {};
        switch (layout.blockName) {
          case 'surecart/product-item-title':
            return h("sc-product-item-title", { part: "title" }, (_a = this.product) === null || _a === void 0 ? void 0 : _a.name);
          case 'surecart/product-item-image':
            return h("sc-product-item-image", { part: "image", product: this.product, sizing: (_b = layout.attributes) === null || _b === void 0 ? void 0 : _b.sizing });
          case 'surecart/product-item-price':
            return h("sc-product-item-price", { part: "price", prices: (_c = this.product) === null || _c === void 0 ? void 0 : _c.prices.data, range: !!(attributes === null || attributes === void 0 ? void 0 : attributes.range), metrics: (_d = this.product) === null || _d === void 0 ? void 0 : _d.metrics });
          default:
            return null;
        }
      })));
  }
  static get style() { return scProductItemCss; }
}, [1, "sc-product-item", {
    "product": [16],
    "layoutConfig": [16]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-item", "sc-format-number", "sc-price-range", "sc-product-item-image", "sc-product-item-price", "sc-product-item-title", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-item":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductItem);
      }
      break;
    case "sc-format-number":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-price-range":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-product-item-image":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-product-item-price":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-product-item-title":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { ScProductItem as S, defineCustomElement as d };

//# sourceMappingURL=sc-product-item2.js.map