import { proxyCustomElement, HTMLElement, h, Fragment } from '@stencil/core/internal/client';
import { s as state, e as isOptionSoldOut, h as isOptionMissing, b as setProduct } from './watchers.js';
import { s as sprintf, _ as __ } from './default-i18n.js';
import { d as defineCustomElement$4 } from './sc-form-control2.js';
import { d as defineCustomElement$3 } from './sc-pill-option2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';

const scProductPillsVariantOptionCss = ".sc-product-pills-variant-option__wrapper{display:flex;flex-wrap:wrap;gap:var(--sc-spacing-x-small)}";

const ScProductPillsVariantOption$1 = /*@__PURE__*/ proxyCustomElement(class ScProductPillsVariantOption extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.label = undefined;
    this.optionNumber = 1;
    this.productId = undefined;
  }
  render() {
    return (h("sc-form-control", { label: this.label }, h("span", { slot: "label" }, this.label), h("div", { class: "sc-product-pills-variant-option__wrapper" }, (state[this.productId].variant_options[this.optionNumber - 1].values || []).map(value => {
      const isUnavailable = isOptionSoldOut(this.productId, this.optionNumber, value) || isOptionMissing(this.productId, this.optionNumber, value);
      return (h("sc-pill-option", { isUnavailable: isUnavailable, isSelected: state[this.productId].variantValues[`option_${this.optionNumber}`] === value, onClick: () => setProduct(this.productId, {
          variantValues: {
            ...state[this.productId].variantValues,
            [`option_${this.optionNumber}`]: value,
          },
        }) }, h("span", { "aria-hidden": "true" }, value), h("sc-visually-hidden", null, sprintf(__('Select %s: %s.', 'surecart'), this.label, value), isUnavailable && h(Fragment, null, " ", __('(option unavailable)', 'surecart')), state[this.productId].variantValues[`option_${this.optionNumber}`] === value && h(Fragment, null, " ", __('This option is currently selected.', 'surecart')))));
    }))));
  }
  static get style() { return scProductPillsVariantOptionCss; }
}, [0, "sc-product-pills-variant-option", {
    "label": [1],
    "optionNumber": [2, "option-number"],
    "productId": [1, "product-id"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-pills-variant-option", "sc-form-control", "sc-pill-option", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-pills-variant-option":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductPillsVariantOption$1);
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-pill-option":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProductPillsVariantOption = ScProductPillsVariantOption$1;
const defineCustomElement = defineCustomElement$1;

export { ScProductPillsVariantOption, defineCustomElement };

//# sourceMappingURL=sc-product-pills-variant-option.js.map