import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { s as state, b as setProduct } from './watchers.js';
import { g as getMaxStockQuantity } from './quantity.js';
import { d as defineCustomElement$5 } from './sc-form-control2.js';
import { d as defineCustomElement$4 } from './sc-icon2.js';
import { d as defineCustomElement$3 } from './sc-quantity-select2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';

const scProductQuantityCss = ":host{display:block}";

let id = 0;
const ScProductQuantity$1 = /*@__PURE__*/ proxyCustomElement(class ScProductQuantity extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.inputId = `sc-quantity-${++id}`;
    this.helpId = `sc-quantity-help-text-${id}`;
    this.labelId = `sc-quantity-label-${id}`;
    this.size = 'medium';
    this.name = undefined;
    this.errors = undefined;
    this.showLabel = true;
    this.label = undefined;
    this.required = false;
    this.help = undefined;
    this.productId = undefined;
  }
  render() {
    var _a, _b, _c, _d, _e;
    const maxStockQuantity = getMaxStockQuantity((_a = state[this.productId]) === null || _a === void 0 ? void 0 : _a.product, (_b = state[this.productId]) === null || _b === void 0 ? void 0 : _b.selectedVariant);
    return (h(Host, null, h("sc-form-control", { exportparts: "label, help-text, form-control", size: this.size, required: this.required, label: this.label, showLabel: this.showLabel, help: this.help, inputId: this.inputId, helpId: this.helpId, labelId: this.labelId, name: this.name }, h("sc-quantity-select", { size: this.size, quantity: Math.max(((_c = state[this.productId].selectedPrice) === null || _c === void 0 ? void 0 : _c.ad_hoc) ? 1 : state[this.productId].quantity, 1), disabled: (_e = (_d = state[this.productId]) === null || _d === void 0 ? void 0 : _d.selectedPrice) === null || _e === void 0 ? void 0 : _e.ad_hoc, onScInput: e => setProduct(this.productId, { quantity: e.detail }), ...(!!maxStockQuantity ? { max: maxStockQuantity } : {}) }))));
  }
  static get style() { return scProductQuantityCss; }
}, [1, "sc-product-quantity", {
    "size": [513],
    "name": [1],
    "errors": [8],
    "showLabel": [4, "show-label"],
    "label": [1],
    "required": [4],
    "help": [1],
    "productId": [1, "product-id"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-quantity", "sc-form-control", "sc-icon", "sc-quantity-select", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-quantity":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductQuantity$1);
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-quantity-select":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProductQuantity = ScProductQuantity$1;
const defineCustomElement = defineCustomElement$1;

export { ScProductQuantity, defineCustomElement };

//# sourceMappingURL=sc-product-quantity.js.map