import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { s as state } from './watchers.js';

const scProductTextCss = ":host{display:block}p{margin-block-start:0;margin-block-end:1em}";

const ScProductText$1 = /*@__PURE__*/ proxyCustomElement(class ScProductText extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.text = 'name';
    this.productId = undefined;
  }
  render() {
    var _a;
    const product = (_a = state[this.productId]) === null || _a === void 0 ? void 0 : _a.product;
    if (product === null || product === void 0 ? void 0 : product[this.text]) {
      return h("span", { style: { whiteSpace: 'pre-line' }, innerHTML: product[this.text] });
    }
    return (h(Host, null, h("slot", null)));
  }
  static get style() { return scProductTextCss; }
}, [1, "sc-product-text", {
    "text": [1],
    "productId": [1, "product-id"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-product-text"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-product-text":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProductText$1);
      }
      break;
  } });
}

const ScProductText = ScProductText$1;
const defineCustomElement = defineCustomElement$1;

export { ScProductText, defineCustomElement };

//# sourceMappingURL=sc-product-text.js.map