import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$2 } from './sc-icon2.js';

const scProvisionalBannerCss = ".sc-banner{background-color:var(--sc-color-brand-primary);color:white;display:flex;align-items:center;justify-content:center}.sc-banner>p{font-size:14px;line-height:1;margin:var(--sc-spacing-small)}.sc-banner>p a{color:inherit;font-weight:600;margin-left:10px;display:inline-flex;align-items:center;gap:8px;text-decoration:none;border-bottom:1px solid;padding-bottom:2px}";

const ScProvisionalBanner$1 = /*@__PURE__*/ proxyCustomElement(class ScProvisionalBanner extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.claimUrl = '';
  }
  render() {
    return (h("div", { class: { 'sc-banner': true } }, h("p", null, __('Complete your store setup to go live.', 'surecart'), h("a", { href: this.claimUrl }, __('Complete Setup', 'surecart'), " ", h("sc-icon", { name: "arrow-right" })))));
  }
  static get style() { return scProvisionalBannerCss; }
}, [1, "sc-provisional-banner", {
    "claimUrl": [1, "claim-url"]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-provisional-banner", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-provisional-banner":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScProvisionalBanner$1);
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScProvisionalBanner = ScProvisionalBanner$1;
const defineCustomElement = defineCustomElement$1;

export { ScProvisionalBanner, defineCustomElement };

//# sourceMappingURL=sc-provisional-banner.js.map