import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { g as getVariantFromValues } from './util.js';
import { d as defineCustomElement$h } from './sc-alert2.js';
import { d as defineCustomElement$g } from './sc-block-ui2.js';
import { d as defineCustomElement$f } from './sc-button2.js';
import { d as defineCustomElement$e } from './sc-card2.js';
import { d as defineCustomElement$d } from './sc-dashboard-module2.js';
import { d as defineCustomElement$c } from './dropdown.js';
import { d as defineCustomElement$b } from './sc-form2.js';
import { d as defineCustomElement$a } from './sc-form-control2.js';
import { d as defineCustomElement$9 } from './sc-icon2.js';
import { d as defineCustomElement$8 } from './sc-input2.js';
import { d as defineCustomElement$7 } from './sc-menu2.js';
import { d as defineCustomElement$6 } from './sc-menu-item2.js';
import { d as defineCustomElement$5 } from './sc-menu-label2.js';
import { d as defineCustomElement$4 } from './sc-select2.js';
import { d as defineCustomElement$3 } from './sc-spinner2.js';
import { d as defineCustomElement$2 } from './sc-visually-hidden2.js';
import { a as addQueryArgs } from './add-query-args.js';

const scSubscriptionVariationConfirmCss = ":host{display:block}.sc-product-variation-choice-wrap{display:flex;flex-direction:column;gap:var(--sc-variation-gap, 12px)}";

const ScSubscriptionVariationConfirm$1 = /*@__PURE__*/ proxyCustomElement(class ScSubscriptionVariationConfirm extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.heading = undefined;
    this.product = undefined;
    this.price = undefined;
    this.subscription = undefined;
    this.busy = false;
    this.variantValues = [];
    // Bind the submit function to the component instance
    this.handleSubmit = this.handleSubmit.bind(this);
  }
  componentWillLoad() {
    var _a;
    this.variantValues = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.variant_options;
  }
  async handleSubmit() {
    var _a, _b, _c, _d;
    this.busy = true;
    const selectedVariant = getVariantFromValues({ variants: (_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.variants) === null || _b === void 0 ? void 0 : _b.data, values: this.variantValues });
    // confirm ad_hoc amount.
    if ((_c = this.price) === null || _c === void 0 ? void 0 : _c.ad_hoc) {
      return window.location.assign(addQueryArgs(window.location.href, {
        action: 'confirm_amount',
        price_id: (_d = this.price) === null || _d === void 0 ? void 0 : _d.id,
        variant: selectedVariant === null || selectedVariant === void 0 ? void 0 : selectedVariant.id,
      }));
    }
    return window.location.assign(addQueryArgs(window.location.href, {
      action: 'confirm',
      variant: selectedVariant === null || selectedVariant === void 0 ? void 0 : selectedVariant.id,
    }));
  }
  buttonText() {
    var _a, _b, _c, _d;
    if ((_a = this.price) === null || _a === void 0 ? void 0 : _a.ad_hoc) {
      if (((_b = this.price) === null || _b === void 0 ? void 0 : _b.id) === ((_d = (_c = this.subscription) === null || _c === void 0 ? void 0 : _c.price) === null || _d === void 0 ? void 0 : _d.id)) {
        return __('Update Amount', 'surecart');
      }
      return __('Choose Amount', 'surecart');
    }
    return __('Next', 'surecart');
  }
  render() {
    var _a, _b;
    return (h("sc-dashboard-module", { heading: this.heading || __('Enter An Amount', 'surecart'), class: "subscription-switch" }, h("sc-card", null, h("sc-form", { onScSubmit: this.handleSubmit }, h("div", { class: "sc-product-variation-choice-wrap" }, (((_b = (_a = this.product) === null || _a === void 0 ? void 0 : _a.variant_options) === null || _b === void 0 ? void 0 : _b.data) || []).map(({ name, values, id }, index) => {
      var _a, _b;
      return (h("sc-select", { exportparts: "base:select__base, input, form-control, label, help-text, trigger, panel, caret, menu__base, spinner__base, empty", part: "name__input", value: ((_b = (_a = this.subscription) === null || _a === void 0 ? void 0 : _a.variant_options) === null || _b === void 0 ? void 0 : _b[index]) || '', onScChange: (e) => {
          this.variantValues[index] = e.detail.value;
        }, label: name, choices: values === null || values === void 0 ? void 0 : values.map(label => ({
          label,
          value: label,
        })), unselect: false, key: id }));
    })), h("sc-button", { type: "primary", full: true, submit: true, loading: this.busy }, this.buttonText(), " ", h("sc-icon", { name: "arrow-right", slot: "suffix" })))), this.busy && h("sc-block-ui", { style: { zIndex: '9' } })));
  }
  static get style() { return scSubscriptionVariationConfirmCss; }
}, [0, "sc-subscription-variation-confirm", {
    "heading": [1],
    "product": [16],
    "price": [16],
    "subscription": [16],
    "busy": [32],
    "variantValues": [32]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-subscription-variation-confirm", "sc-alert", "sc-block-ui", "sc-button", "sc-card", "sc-dashboard-module", "sc-dropdown", "sc-form", "sc-form-control", "sc-icon", "sc-input", "sc-menu", "sc-menu-item", "sc-menu-label", "sc-select", "sc-spinner", "sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-subscription-variation-confirm":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScSubscriptionVariationConfirm$1);
      }
      break;
    case "sc-alert":
      if (!customElements.get(tagName)) {
        defineCustomElement$h();
      }
      break;
    case "sc-block-ui":
      if (!customElements.get(tagName)) {
        defineCustomElement$g();
      }
      break;
    case "sc-button":
      if (!customElements.get(tagName)) {
        defineCustomElement$f();
      }
      break;
    case "sc-card":
      if (!customElements.get(tagName)) {
        defineCustomElement$e();
      }
      break;
    case "sc-dashboard-module":
      if (!customElements.get(tagName)) {
        defineCustomElement$d();
      }
      break;
    case "sc-dropdown":
      if (!customElements.get(tagName)) {
        defineCustomElement$c();
      }
      break;
    case "sc-form":
      if (!customElements.get(tagName)) {
        defineCustomElement$b();
      }
      break;
    case "sc-form-control":
      if (!customElements.get(tagName)) {
        defineCustomElement$a();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$9();
      }
      break;
    case "sc-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$8();
      }
      break;
    case "sc-menu":
      if (!customElements.get(tagName)) {
        defineCustomElement$7();
      }
      break;
    case "sc-menu-item":
      if (!customElements.get(tagName)) {
        defineCustomElement$6();
      }
      break;
    case "sc-menu-label":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-select":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-spinner":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScSubscriptionVariationConfirm = ScSubscriptionVariationConfirm$1;
const defineCustomElement = defineCustomElement$1;

export { ScSubscriptionVariationConfirm, defineCustomElement };

//# sourceMappingURL=sc-subscription-variation-confirm.js.map