import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const scTableRowCss = ":host{display:table-row;border:1px solid var(--sc-table-row-border-bottom-color, var(--sc-color-gray-200))}:host([href]){cursor:pointer}:host([href]:hover){background:var(--sc-color-gray-50)}";

const ScTableRow = /*@__PURE__*/ proxyCustomElement(class ScTableRow extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.href = undefined;
  }
  render() {
    return (h(Host, null, h("slot", null)));
  }
  static get style() { return scTableRowCss; }
}, [1, "sc-table-row", {
    "href": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-table-row"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-table-row":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScTableRow);
      }
      break;
  } });
}

export { ScTableRow as S, defineCustomElement as d };

//# sourceMappingURL=sc-table-row2.js.map