import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';

const scTableCss = ":host{display:table;width:100%;height:100%;border-spacing:0;border-collapse:collapse;table-layout:fixed;font-family:var(--sc-font-sans);border-radius:var(--border-radius, var(--sc-border-radius-small))}:host([shadowed]){box-shadow:var(--sc-shadow-medium)}::slotted([slot=head]){border-bottom:1px solid var(--sc-table-border-bottom-color, var(--sc-color-gray-200))}";

const ScTable = /*@__PURE__*/ proxyCustomElement(class ScTable extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return (h(Host, null, h("slot", { name: "head" }), h("slot", null), h("slot", { name: "footer" })));
  }
  static get style() { return scTableCss; }
}, [1, "sc-table"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-table"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-table":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScTable);
      }
      break;
  } });
}

export { ScTable as S, defineCustomElement as d };

//# sourceMappingURL=sc-table2.js.map