import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { _ as __ } from './default-i18n.js';
import { d as defineCustomElement$5 } from './sc-button2.js';
import { d as defineCustomElement$4 } from './sc-dialog2.js';
import { d as defineCustomElement$3 } from './sc-icon2.js';
import { d as defineCustomElement$2 } from './sc-spinner2.js';

const scUpgradeRequiredCss = ":host{display:inline-block;color:var(--sc-color-gray-900);cursor:pointer}p,::slotted(p){font-size:var(--sc-font-size-medium) !important;font-weight:var(--sc-font-weight-normal);margin:0 0 var(--sc-spacing-medium) 0 !important;line-height:var(--sc-line-height-dense);white-space:normal}.trigger{pointer-events:auto}.trigger__disabled{pointer-events:none}.dialog__title{display:flex;gap:0.5em;align-items:center}.dialog__title sc-icon{font-size:18px;width:22px;stroke-width:4;color:var(--sc-color-primary-500)}";

const ScUpgradeRequired$1 = /*@__PURE__*/ proxyCustomElement(class ScUpgradeRequired extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.size = 'small';
    this.required = true;
    this.open = false;
  }
  render() {
    if (!this.required) {
      return (h(Host, null, h("slot", null)));
    }
    return (h(Host, { onClick: () => (this.open = true) }, h("span", { class: "trigger" }, h("span", { class: "trigger__disabled" }, h("slot", null, h("sc-premium-badge", null)))), h("sc-dialog", { label: __('Boost Your Revenue', 'surecart'), open: this.open, onScRequestClose: () => {
        this.open = false;
        return true;
      }, style: { '--width': '21rem', 'fontSize': '15px', '--body-spacing': '2rem' } }, h("span", { class: "dialog__title", slot: "label" }, h("sc-icon", { name: "zap" }), h("span", null, __('Boost Your Revenue', 'surecart'))), h("slot", { name: "content" }, h("p", null, __('Unlock revenue boosting features when you upgrade your plan!', 'surecart'))), h("sc-button", { href: "https://app.surecart.com/billing", type: "primary", target: "_blank", full: true }, __('Upgrade Now', 'surecart'), h("sc-icon", { name: "arrow-right", slot: "suffix" })))));
  }
  static get style() { return scUpgradeRequiredCss; }
}, [1, "sc-upgrade-required", {
    "size": [513],
    "required": [516],
    "open": [1028]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-upgrade-required", "sc-button", "sc-dialog", "sc-icon", "sc-spinner"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-upgrade-required":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScUpgradeRequired$1);
      }
      break;
    case "sc-button":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "sc-dialog":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "sc-spinner":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScUpgradeRequired = ScUpgradeRequired$1;
const defineCustomElement = defineCustomElement$1;

export { ScUpgradeRequired, defineCustomElement };

//# sourceMappingURL=sc-upgrade-required.js.map