import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as getFormattedRemainingTime } from './getters.js';
import { d as defineCustomElement$2 } from './sc-icon2.js';

const scUpsellCountdownTimerCss = ":host{display:flex;justify-content:var(--sc-upsell-countdown-timer-justify-content, center);align-items:var(--sc-upsell-countdown-timer-align-items, center);text-align:var(--sc-upsell-countdown-timer-text-align, center);flex-wrap:wrap;gap:var(--sc-upsell-countdown-timer-gap, 0.5em);line-height:1;padding:var(--sc-upsell-countdown-timer-padding, var(--sc-spacing-medium));border-radius:var(--sc-upsell-countdown-timer-border-radius, var(--sc-border-radius-pill));background-color:var(--sc-upsell-countdown-timer-background-color, rgb(226, 249, 235));color:var(--sc-upsell-countdown-timer-color, rgb(71, 91, 80))}";

const ScUpsellCountdownTimer$1 = /*@__PURE__*/ proxyCustomElement(class ScUpsellCountdownTimer extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.timeRemaining = Infinity;
    this.formattedTime = undefined;
    this.showIcon = true;
  }
  componentDidLoad() {
    this.updateCountdown();
  }
  updateCountdown() {
    this.formattedTime = getFormattedRemainingTime();
    setInterval(() => {
      this.formattedTime = getFormattedRemainingTime();
    }, 1000);
  }
  render() {
    return (h(Host, { role: "timer", class: {
        'sc-upsell-countdown-timer': true,
      } }, this.showIcon && h("sc-icon", { name: "clock" }), h("span", null, h("slot", { name: "offer-expire-text" }), " ", h("strong", null, this.formattedTime))));
  }
  static get style() { return scUpsellCountdownTimerCss; }
}, [1, "sc-upsell-countdown-timer", {
    "showIcon": [4, "show-icon"],
    "timeRemaining": [32],
    "formattedTime": [32]
  }]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-upsell-countdown-timer", "sc-icon"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-upsell-countdown-timer":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScUpsellCountdownTimer$1);
      }
      break;
    case "sc-icon":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
  } });
}

const ScUpsellCountdownTimer = ScUpsellCountdownTimer$1;
const defineCustomElement = defineCustomElement$1;

export { ScUpsellCountdownTimer, defineCustomElement };

//# sourceMappingURL=sc-upsell-countdown-timer.js.map