import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import './watchers2.js';
import { s as state } from './store.js';
import { s as state$1 } from './store2.js';
import { i as isProductOutOfStock, c as isSelectedVariantMissing } from './watchers.js';
import { a as accept } from './mutations.js';
import { c as isBusy } from './getters.js';

const scUpsellSubmitButtonCss = "sc-upsell-submit-button{position:relative;display:block}sc-upsell-submit-button .wp-block-button__link{position:relative;text-decoration:none}sc-upsell-submit-button .wp-block-button__link span sc-icon{padding-right:var(--sc-spacing-small)}sc-upsell-submit-button .wp-block-button__link [data-text],sc-upsell-submit-button .wp-block-button__link sc-spinner{display:flex;align-items:center;justify-content:center}sc-upsell-submit-button .sc-block-button--sold-out,sc-upsell-submit-button .sc-block-button--unavailable{display:none !important}sc-upsell-submit-button.is-unavailable .sc-block-button__link{display:none !important}sc-upsell-submit-button.is-unavailable .sc-block-button--unavailable{display:initial !important}sc-upsell-submit-button.is-sold-out .sc-block-button__link{display:none !important}sc-upsell-submit-button.is-sold-out .sc-block-button--sold-out{display:initial !important}sc-upsell-submit-button sc-spinner::part(base){--indicator-color:currentColor;--spinner-size:12px;position:absolute;top:calc(50% - var(--spinner-size) + var(--spinner-size) / 4);left:calc(50% - var(--spinner-size) + var(--spinner-size) / 4)}sc-upsell-submit-button [data-text],sc-upsell-submit-button [data-loader]{transition:opacity var(--sc-transition-fast) ease-in-out, visibility var(--sc-transition-fast) ease-in-out}sc-upsell-submit-button [data-loader]{opacity:0;visibility:hidden}sc-upsell-submit-button.is-disabled{pointer-events:none}sc-upsell-submit-button.is-busy [data-text]{opacity:0;visibility:hidden}sc-upsell-submit-button.is-busy [data-loader]{opacity:1;visibility:visible}sc-upsell-submit-button.is-out-of-stock [data-text]{opacity:0.6}";

const ScUpsellSubmitButton$1 = /*@__PURE__*/ proxyCustomElement(class ScUpsellSubmitButton extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
  }
  getUpsellProductId() {
    var _a;
    return ((_a = state.product) === null || _a === void 0 ? void 0 : _a.id) || '';
  }
  async handleAddToOrderClick(e) {
    e.preventDefault();
    accept();
  }
  render() {
    return (h(Host, { class: {
        'is-busy': isBusy(),
        'is-disabled': state.disabled,
        // TODO: change this to out of stock error message.
        'is-sold-out': (isProductOutOfStock(this.getUpsellProductId()) && !isSelectedVariantMissing(this.getUpsellProductId())) || (state$1 === null || state$1 === void 0 ? void 0 : state$1.code) === 'out_of_stock',
        'is-unavailable': isSelectedVariantMissing(this.getUpsellProductId()) || (state$1 === null || state$1 === void 0 ? void 0 : state$1.code) === 'expired',
      }, onClick: e => this.handleAddToOrderClick(e) }, h("slot", null)));
  }
  get el() { return this; }
  static get style() { return scUpsellSubmitButtonCss; }
}, [4, "sc-upsell-submit-button"]);
function defineCustomElement$1() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-upsell-submit-button"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-upsell-submit-button":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScUpsellSubmitButton$1);
      }
      break;
  } });
}

const ScUpsellSubmitButton = ScUpsellSubmitButton$1;
const defineCustomElement = defineCustomElement$1;

export { ScUpsellSubmitButton, defineCustomElement };

//# sourceMappingURL=sc-upsell-submit-button.js.map