import { proxyCustomElement, HTMLElement, h } from '@stencil/core/internal/client';

const scVisuallyHiddenCss = ":host(:not(:focus-within)){position:absolute !important;width:1px !important;height:1px !important;clip:rect(0 0 0 0) !important;clip-path:inset(50%) !important;border:none !important;overflow:hidden !important;white-space:nowrap !important;padding:0 !important}";

const ScVisuallyHidden = /*@__PURE__*/ proxyCustomElement(class ScVisuallyHidden extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  render() {
    return h("slot", null);
  }
  static get style() { return scVisuallyHiddenCss; }
}, [1, "sc-visually-hidden"]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["sc-visually-hidden"];
  components.forEach(tagName => { switch (tagName) {
    case "sc-visually-hidden":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, ScVisuallyHidden);
      }
      break;
  } });
}

export { ScVisuallyHidden as S, defineCustomElement as d };

//# sourceMappingURL=sc-visually-hidden2.js.map