/**
 * Track an event with Google Analytics or Google Tag Manager
 *
 * @param googleEventName The name of the event to track
 * @param eventData The data to send with the event
 *
 * @returns void
 */
const trackEvent = (googleEventName, eventData) => {
  if (!(window === null || window === void 0 ? void 0 : window.dataLayer) && !(window === null || window === void 0 ? void 0 : window.gtag))
    return;
  if (!eventData)
    return;
  // Handle dataLayer for Google Tag Manager
  if (window === null || window === void 0 ? void 0 : window.dataLayer) {
    window.dataLayer.push({ ecommerce: null }); // Clear previous ecommerce transactions
    window.dataLayer.push({
      event: googleEventName,
      ecommerce: eventData,
    });
  }
  else {
    // Handle gtag for Google Analytics
    window.gtag('event', googleEventName, eventData);
  }
};

export { trackEvent as t };

//# sourceMappingURL=google-e0fc1ce3.js.map