import { r as registerInstance, h } from './index-644f5478.js';
import { _ as __ } from './default-i18n-62fa2f9c.js';
import './index-6db066f7.js';

const scOrderStatusBadgeCss = ":host{display:inline-block}";

const ScOrderStatusBadge = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.status = undefined;
    this.size = 'medium';
    this.pill = false;
    this.clearable = false;
  }
  getType() {
    switch (this.status) {
      case 'processing':
        return 'warning';
      case 'paid':
        return 'success';
      case 'payment_failed':
        return 'danger';
      case 'canceled':
        return 'danger';
      case 'void':
        return 'danger';
      case 'canceled':
        return 'danger';
    }
  }
  getText() {
    switch (this.status) {
      case 'processing':
        return __('Processing', 'surecart');
      case 'payment_failed':
        return __('Payment Failed', 'surecart');
      case 'paid':
        return __('Paid', 'surecart');
      case 'canceled':
        return __('Canceled', 'surecart');
      case 'void':
        return __('Canceled', 'surecart');
      default:
        return this.status;
    }
  }
  render() {
    return (h("sc-tag", { type: this.getType(), pill: this.pill }, this.getText()));
  }
};
ScOrderStatusBadge.style = scOrderStatusBadgeCss;

export { ScOrderStatusBadge as sc_order_status_badge };

//# sourceMappingURL=sc-order-status-badge.entry.js.map