import { r as registerInstance, h, a as getElement, H as Host } from './index-644f5478.js';
import { _ as __ } from './default-i18n-62fa2f9c.js';
import { s as state } from './watchers-abe548eb.js';
import './index-6db066f7.js';
import './index-1046c77e.js';
import './utils-00526fde.js';
import './getters-122aba7e.js';
import './mutations-375ca3f1.js';
import './get-query-arg-cb6b8763.js';
import './add-query-args-f4c5962b.js';
import './index-5d62922a.js';
import './default-i18n-05e993b1.js';
import './google-e0fc1ce3.js';
import './currency-728311ef.js';
import './util-64ee5262.js';
import './mutations-f4aa55bd.js';
import './mutations-2805d514.js';
import './store-a9dd117c.js';
import './mutations-7adc8e81.js';
import './index-b47940cd.js';
import './fetch-6efc9f7d.js';

const scProductDonationChoicesCss = ":host{display:block}.sc-product-donation-choices{display:grid;gap:2em;position:relative;--columns:4}.sc-product-donation-choices__form{display:grid;gap:var(--sc-spacing-small)}.sc-donation-recurring-choices{display:grid;gap:var(--sc-spacing-small);position:relative;--columns:2}";

const ScProductDonationChoice = class {
  constructor(hostRef) {
    registerInstance(this, hostRef);
    this.productId = undefined;
    this.label = undefined;
    this.recurring = undefined;
  }
  state() {
    return state[this.productId];
  }
  updateState(data) {
    state[this.productId] = {
      ...state[this.productId],
      ...data,
    };
  }
  render() {
    var _a, _b, _c, _d;
    const prices = (((_c = (_b = (_a = this.state()) === null || _a === void 0 ? void 0 : _a.product) === null || _b === void 0 ? void 0 : _b.prices) === null || _c === void 0 ? void 0 : _c.data) || [])
      .filter(price => (this.recurring ? (price === null || price === void 0 ? void 0 : price.recurring_interval) && (price === null || price === void 0 ? void 0 : price.ad_hoc) : !(price === null || price === void 0 ? void 0 : price.recurring_interval) && (price === null || price === void 0 ? void 0 : price.ad_hoc)))
      .filter(price => !(price === null || price === void 0 ? void 0 : price.archived));
    // no prices, or less than 2 prices, we have no choices.
    if (!(prices === null || prices === void 0 ? void 0 : prices.length)) {
      return h(Host, { style: { display: 'none' } });
    }
    // return price choice container.
    return (h("sc-recurring-price-choice-container", { prices: prices.sort((a, b) => (a === null || a === void 0 ? void 0 : a.position) - (b === null || b === void 0 ? void 0 : b.position)), product: (_d = this.state()) === null || _d === void 0 ? void 0 : _d.product, selectedPrice: this.state().selectedPrice, showDetails: false, showAmount: false, onScChange: e => {
        var _a, _b;
        const selectedPrice = (((_b = (_a = this.state().product) === null || _a === void 0 ? void 0 : _a.prices) === null || _b === void 0 ? void 0 : _b.data) || []).find(({ id }) => id == e.detail);
        this.updateState({ selectedPrice });
      }, "aria-label": this.recurring
        ? __('If you want to make your donation recurring then Press Tab once & select the recurring interval from the dropdown. ', 'surecart')
        : __('If you want to make your donation once then Press Enter. ', 'surecart'), style: { '--sc-recurring-price-choice-white-space': 'wrap', '--sc-recurring-price-choice-text-align': 'left' } }, h("slot", null, this.label)));
  }
  get el() { return getElement(this); }
};
ScProductDonationChoice.style = scProductDonationChoicesCss;

export { ScProductDonationChoice as sc_product_donation_choices };

//# sourceMappingURL=sc-product-donation-choices.entry.js.map