const isValidURL = str => {
  let url;
  try {
    url = new URL(str);
  }
  catch (_) {
    return false;
  }
  return url.protocol === 'http:' || url.protocol === 'https:';
};
const getValueFromUrl = (key) => {
  const queryString = window.location.search;
  const urlParams = new URLSearchParams(queryString);
  return urlParams.get(key);
};
const sortByArray = (item, key, orderArray) => (item || []).sort((a, b) => {
  if (orderArray.indexOf(a === null || a === void 0 ? void 0 : a[key]) === -1)
    return 1;
  if (orderArray.indexOf(b === null || b === void 0 ? void 0 : b[key]) === -1)
    return -1;
  return orderArray.indexOf(a === null || a === void 0 ? void 0 : a[key]) - orderArray.indexOf(b === null || b === void 0 ? void 0 : b[key]);
});
const getVariantFromValues = ({ variants, values }) => {
  const variantValueKeys = Object.keys(values);
  for (const variant of variants) {
    const variantValues = ['option_1', 'option_2', 'option_3'].map(option => variant[option]).filter(value => value !== null && value !== undefined);
    if ((variantValues === null || variantValues === void 0 ? void 0 : variantValues.length) === (variantValueKeys === null || variantValueKeys === void 0 ? void 0 : variantValueKeys.length) && variantValueKeys.every(key => variantValues.includes(values[key]))) {
      return variant;
    }
  }
  return null;
};
const isInRange = (value, price) => {
  const valueInt = parseInt(value);
  if (!price)
    return true;
  if (!(price === null || price === void 0 ? void 0 : price.ad_hoc_max_amount) && !(price === null || price === void 0 ? void 0 : price.ad_hoc_min_amount))
    return true;
  if ((price === null || price === void 0 ? void 0 : price.ad_hoc_max_amount) && valueInt > (price === null || price === void 0 ? void 0 : price.ad_hoc_max_amount))
    return false;
  if ((price === null || price === void 0 ? void 0 : price.ad_hoc_min_amount) && valueInt < (price === null || price === void 0 ? void 0 : price.ad_hoc_min_amount))
    return false;
  return true;
};

export { getValueFromUrl as a, isValidURL as b, getVariantFromValues as g, isInRange as i, sortByArray as s };

//# sourceMappingURL=util-64ee5262.js.map