export type IconLibraryResolver = (name: string) => string;
export type IconLibraryMutator = (svg: SVGElement) => void;
export interface IconLibrary {
  name: string;
  resolver: IconLibraryResolver;
  mutator?: IconLibraryMutator;
}
export declare function watchIcon(icon: any): void;
export declare function unwatchIcon(icon: any): void;
export declare function getIconLibrary(name?: string): IconLibrary;
export declare function registerIconLibrary(name: string, options: {
  resolver: IconLibraryResolver;
  mutator?: IconLibraryMutator;
}): void;
export declare function unregisterIconLibrary(name: string): void;
